#include "stdafx.h"
#include <ablib/TextFile.h>
#include <ablib/KRSearch.h>
#include <HmJre_dll/RegEx.h>
#include <ablib/lexical_cast.h>
#include <ablib/IsKanji.h>
#include <window/Dialog.h>
#include <algorithm>
#include <numeric>
#include "bibtex.h"
#include "ExportFunc.h"

extern HINSTANCE g_dllint;


BibTeX::BibTeX() : BaseModalDlg(g_dllint){}

ablib::string BibTeX::CreateList(const ablib::string &f){
	ablib::string rv;
	ablib::TextFile tf;
	if(!tf.Open(f,ablib::TextFile::read)){
		::SetmacrodllLastError(_T("t@CJ܂łD"));
		return _T("");
	}
	HmJre::RegEx search(_T("\\\\bibliography\\{|\\\\(addbibresource|addglobalbib|addsectionbib)(\\[.*?\\])?\\{"));
#ifdef DEBUG
	if(!search.IsCompiled()){
		::SetmacrodllLastError(_T("K\RpCɎsD"));
		return _T("");
	}
#endif
	TCHAR buf[4096];
	while(tf.ReadLine(buf,4095)){
		if(search.Match(buf)){
			TCHAR *q = buf + search.GetMatchPos() + search.GetMatchLen();//lstrlen(_T("\\bibliography{")) = 14
			TCHAR *p;
			for(p = q; *p != '\0' && *p != '}' ; ++p);
			*p = '\0';
			if(rv != _T(""))rv += _T(" ");
			p = q;
			while(true){
				if(*p == ',' || *p == '\0'){
					rv.append(q,0,p - q);
					if(!(p - q >= 4 && 
						(*(p - 1) == 'b' || *(p - 1) == 'B') &&
						(*(p - 2) == 'i' || *(p - 2) == 'I') &&
						(*(p - 3) == 'b' || *(p - 3) == 'B') &&
						*(p - 4) == '.'))rv += _T(".bib");
					rv += _T(" ");
					q = p + 1;
				}
				if(*p == '\0')break;
#ifdef UNICODE
				p += 1;
#else
				p += ablib::IsKanji(*p) ? 2 : 1;
#endif
			}
		}
	}
	tf.Close();

	return rv;
}

intptr_t BibTeX::AnalyzeBib(const ablib::string &file,bool clsresult){
	if(clsresult)m_data.clear();
	ablib::TextFile tf;
	if(!tf.Open(file,ablib::TextFile::read))return 0;
	TCHAR buf[4096];
	BibDATA data;
	ablib::string instr,item;

	int rv = 0;
	if(!tf.ReadLine(buf,4095))return 0;
	TCHAR *p = buf;//p = ׂĂꏊ
	// [v͈PACeD
	while(true){
		// @
#ifdef UNICODE
		for(;*p != '@' ; ++p){
#else
		for(;*p != '@' ; p += ablib::IsKanji(*p) ? 2 : 1){
#endif
			if(*p == '\0'){
				if(!tf.ReadLine(buf,4095))return rv;
				else p = buf;
				if(*p == '@')break;
			}
		}
		++p;
		// '@'̌'{'̑O܂ł荞݁D͕ނĂD
		data.bunrui = _T("");
		while(true){
			TCHAR *q = p;
#ifdef UNICODE
			while(*q != '{' && *q != '(' && *q != '\0')++q;
#else
			while(*q != '{' && *q != '(' && *q != '\0')q += ablib::IsKanji(*q) ? 2 : 1;
#endif
			if(*q == '\0'){
				// 0ɒӁDZoȂ̂p = buf*buf = '\0'D
				if(*buf)--q;
				if(*q == '\n')*q = '\0';//s폜
				data.bunrui.append(p);
				if(!tf.ReadLine(buf,4095)){tf.Close();return rv;}
				p = buf;continue;
			}else{
				data.bunrui.append(p,0,q - p);
				p = q + 1;
				break;
			}
		}
		// ̋󔒁C^u폜
		intptr_t j = data.bunrui.length() - 1;
		while((data.bunrui[j] == ' ' || data.bunrui[j] == '\t') && j >= 0)--j;
		if(j < 0)data.bunrui = _T("");
		else data.bunrui.erase(j + 1);
		data.bunrui.tolower();
		// ނΏۂłȂClXgI܂ŃXLbvD
		if(!CheckBunrui(data.bunrui)){
			int nest = 1;
			while(nest > 0){
				if(nest == 1 && *p == '}')break;
				if(*p == '{'){++nest;++p;}
				else if(*p == '}'){--nest;++p;}
				else if(*p == '\0'){
					if(!tf.ReadLine(buf,4095)){tf.Close();return rv;}
					else p = buf;
#ifdef UNICODE
				}else ++p;
#else
				}else p += ablib::IsKanji(*p) ? 2 : 1;
#endif
			}
			continue;
		}
		// Ƀx荞݂ɂD
		data.label = _T("");
		// ܂͋󔒃XLbv
		while(true){
#ifdef UNICODE
			while((*p == ' ' || *p == '\t' || *p == '\n') && *p != '\0')++p;
#else
			while((*p == ' ' || *p == '\t' || *p == '\n') && *p != '\0')p += ablib::IsKanji(*p) ? 2 : 1;
#endif
			if(*p == '\0'){
				if(!tf.ReadLine(buf,4095)){tf.Close();return rv;}
				else{p = buf;continue;}
			}else break;
		}
		// Ɂu,vD܂łxDނƊSɓ@D
		while(true){
			TCHAR *q = p;
#ifdef UNICODE
			while(*q != ',' && *q != '\0')++q;
#else
			while(*q != ',' && *q != '\0')q += ablib::IsKanji(*q) ? 2 : 1;
#endif
			if(*p == '\0'){
				if(*buf)--q;
				if(*q == '\n')*q = '\0';
				data.label.append(p);							
				if(!tf.ReadLine(buf,4095)){tf.Close();return rv;}
				else{p = buf;continue;}
			}else{
				data.label.append(p,0,q - p);
				p = q + 1;
				break;
			}
		}

		while(true){
			// u,vŋ؂D
			int nest = 0;bool dq = false;
			instr = _T("");
			TCHAR *q = p;
			bool end = false;
			while(true){
				if(nest < 0){end = true;break;}
//				else if(nest == 0 && !dq && *q == '('){end = true;break;}
				if(*q == '\0'){
					// I[Ȃǂݍ
					if(*buf)--q;
					if(*q == '\n')*q = ' ';// s͋󔒂ɁD
					instr.append(p);
					if(!tf.ReadLine(buf,4095)){tf.Close();return rv;}
					else{q = p = buf;continue;}
				}else if(*q == '{'){
					// '{'ꂽCu"v̒ɂȂlXg{PD
					if(!dq)++nest;
					++q;
					continue;
				}else if(*q == '}'){
					// '}'ꂽCu"v̒ɂȂlXg|PD
					if(!dq)--nest;
					++q;
					continue;
				}else if(*q == ','){
					// ','ꂽ{IɏID
					if(nest == 0 && !dq){
						instr.append(p,0,q - p);
						p = q + 1;
						break;
					}else{++q;continue;}
				}else if(*p == '\"'){
					// '"'ꂽClXgĂȂdqɂƂtO
					if(nest == 0)dq = !dq;
					++q;
					continue;
#ifdef UNICODE
				}else ++q;
#else
				}else q += ablib::IsKanji(*q) ? 2 : 1;
#endif
			}
			//instr̉͊JnD
			bool isvalid = false;
			std::vector<ablib::string>::size_type i;
#ifdef UNICODE
			for(i = 0 ; i < instr.length() ; ++i){
#else
			for(i = 0 ; i < instr.length() ; i += ablib::IsKanji(instr[i]) ? 2 : 1){
#endif
				if(instr[i] == '='){isvalid  = true;break;}
				else if(instr[i] == '{' || instr[i] == '\"')break;
			}
			if(!isvalid){
				if(end)break;
				else continue;
			}


			// '='̑O܂ł擾
			item = instr.substr(0,i);
			instr.erase(0,i + 1);
			// item̓ƌ̋󔒁C^u폜
			j = 0;
			while(item[j] == ' ' || item[j] == '\t')++j;
			item.erase(0,j);
			j = item.length() - 1;
			while((item[j] == ' ' || item[j] == '\t') && j >= 0)--j;
			if(j < 0)item = _T("");
			else item.erase(j + 1);
			item.tolower();

			if(item == _T("title") || item == _T("author")){
				// instr󔒍폜
				j = 0;
				while(instr[j] == ' ' || instr[j] == '\t')++j;
				instr.erase(0,j);
				j = instr.length() - 1;
				while((instr[j] == ' ' || instr[j] == '\t') && j >= 0)--j;
				if(j < 0)instr = _T("");
				else instr.erase(j + 1);
				// Ƃۂ'"','{','}'͎菜
				if(instr != _T("")){
					if(instr[0] == '{' || instr[0] == '\"')instr.erase(0,1);
					if(instr[instr.length() - 1] == '}' || instr[instr.length() - 1] == '\"')instr.erase(instr.length() - 1);
				}
				// f[^̃Zbg
				instr = ExportFunc::GSUB(instr.c_str(), "[ \t][ \t]*", " ", TRUE, FALSE);
				if(item == _T("title"))data.title = instr;
				else if(item == _T("author"))data.author = instr;
				else if(item == _T("note"))data.note = instr;
			}
			if(end)break;
		}
		// ܂łĂƉ͊D
		data.CreateSearchStr();
		m_data.push_back(data);
		++rv;
		data.clear();
	}
	return rv;
}

bool BibTeX::CheckBunrui(const ablib::string &b){
/*
	return (
		b == _T("article") || b == _T("book") ||  b == _T("unpublished")|| b == _T("incollection") ||
		b == _T("booklet") || b == _T("inbook") || b == _T("inproceedings") || b == _T("manual") ||
		b == _T("mastersthesis") ||	b == _T("misc") || b == _T("phdthesis") || b == _T("proceedings") ||
		b == _T("techreport") || b == _T("conference"));
*/
	return (b != _T("string") && b != _T("preamble") && b != _T("comment"));
}

void BibTeX::UnEscape(ablib::string &str){
	ablib::string rv;
	rv.reserve(str.length() + 30);
	ablib::string::size_type p = 0;
	for(ablib::string::size_type i = 0 ; i < str.length() ; ++i){
		if(str[i] == '\\'){
			rv.append(str,p,i - p);
			p = i + 1;
			rv += _T("\\\\");
		}else if(str[i] == '\n'){
			rv.append(str,p,i - p);
			p = i + 1;
			rv += _T("\\n");
		}
#ifndef UNICODE
		else if(ablib::IsKanji(str[i]))++i;
#endif
	}
	rv.append(str,p,ablib::string::npos);
	str = rv;
}

void BibTeX::ToFile(const TCHAR *label,const TCHAR *other){
	FILE *lfp,*ofp;
	if(label && *label)lfp = ::_tfopen(label,_T("a+"));
	else lfp = NULL;
	if(other && *other)ofp = ::_tfopen(other,_T("a+"));
	else ofp = NULL;
	ablib::string owrite;
	for(std::vector<BibDATA>::size_type i = 0 ; i < m_data.size() ; ++i){
		if(lfp)::_ftprintf(lfp,_T("%s\n"),m_data[i].label.c_str());
		if(ofp){
			owrite = _T("author : ") + m_data[i].author + _T("\ntitle : ") + m_data[i].title;
			UnEscape(owrite);
			::_ftprintf(ofp,_T("%s\n"),owrite.c_str());
		}
	}
	if(lfp)::fclose(lfp);
	if(ofp)::fclose(ofp);
	return;
}

void BibTeX::BibDATA::CreateSearchStr(){
	searchstr = author + _T(" ") + title + _T(" ") + note;
	const TCHAR *del[] = {
		_T("{"),_T("}"),_T("$"),_T("\\`"),_T("\\\'"),_T("\\^"),_T("\\\""),
		_T("\\~"),_T("\\="),_T("\\."),_T("\\v"),_T("\\c"),NULL
	};
	for(const TCHAR **p = del ; *p ; ++p)searchstr.replace(*p,_T(""));
}

intptr_t BibTeX::SearchDlg(HWND hwnd,const TCHAR *ini){
	SearchDialog sd;
	ablib::window::Wnd w(hwnd);
	if(sd.CreateDlg(&w,ini,false)){
		if(sd.GetResult().search == _T("")){
			m_showdata = m_data;
		}else{
			HmJre::RegEx reg;
			reg.SetOpt(_T("CaseSense"),sd.GetResult().CaseSense);
			reg.SetOpt(_T("word"),sd.GetResult().word);
			reg.SetOpt(_T("aimai"),sd.GetResult().fuzzy);
			reg.SetOpt(_T("use_regular"),sd.GetResult().use_regular);
			if(!reg.Compile(sd.GetResult().search)){
				::MessageBox(hwnd,_T("sȐK\łD"),_T("j"),0);
			}else{
				m_showdata.clear();
				for(std::vector<ablib::string>::size_type i = 0 ; i < m_data.size() ; ++i){
					if(reg.Match(m_data[i].searchstr))m_showdata.push_back(m_data[i]);
				}
				if(m_showdata.empty()){
					w.MsgBox(sd.GetResult().search + _T("܂łD"),_T("j"));
				}
			}
		}
		return m_showdata.size();
	}else return 0;
}

const TCHAR *BibTeX::ShowResult(HWND hwnd,const TCHAR *ini){
	ablib::window::Wnd w(hwnd);m_ini = ini;
	if(BaseModalDlg::Create(&w,IDD_BIBRESULT))return m_rv.c_str();
	else return _T("");
}

bool BibTeX::SearchDialog::OnInitDialog(ablib::window::Dialog *wnd){
	wnd->SetTitle(_T("BibTeXf[^x[X̌"));
	// HmJrẽo[W\
	WORD ver = HmJre::RegEx::GetVer();
	ablib::window::StaticText(wnd,IDC_HMJRE_VERSION).SetText(
		_T("HmJre.dll Version ") + 
		ablib::lexical_cast<ablib::string>((0xFF00 & ver) / 256) + 
		_T(".") + 
		ablib::lexical_cast<ablib::string>(((ver & 0xF0)/16) * 10 + (ver & 0xF)));
	ablib::window::Combo searchtext(wnd,IDC_SEARCHTEXT);
	for(int i = 0 ; i < 20 ; ++i){
		ablib::string hist = GetHistory(i);
		if(hist == _T(""))break;
		searchtext.AddString(hist.c_str());
	}
	ablib::window::CheckBox(wnd,IDC_CASESENSE).SetCheck(GetINIInt(_T("Search"),_T("CaseSense")) != FALSE);
	ablib::window::CheckBox(wnd,IDC_WORD).SetCheck(GetINIInt(_T("Search"),_T("word")) != FALSE);
	ablib::window::CheckBox(wnd,IDC_FUZZY).SetCheck(GetINIInt(_T("Search"),_T("Fuzzy")) != FALSE);
	ablib::window::CheckBox(wnd,IDC_REGEX).SetCheck(GetINIInt(_T("Search"),_T("RegEx")) != FALSE);
	if(m_UseSiborikomi){
//		ablib::window::CheckBox(wnd,IDC_SIBORIKOMI).SetCheck(GetINIInt(_T("Search"),_T("Siborikomi")) != FALSE);
		ablib::window::CheckBox(wnd,IDC_SIBORIKOMI).SetCheck(true);
	}
	AddSubClass(&m_sstr,ablib::window::Combo(wnd,IDC_SEARCHTEXT).GetEdit().GetHWND());
//	::SetWindowLong(wnd->GetHWND(),GWL_STYLE,::GetWindowLong(wnd->GetHWND(),GWL_STYLE) | WS_THICKFRAME);

	return true;
}

bool BibTeX::SearchDialog::OnCommand(ablib::window::Dialog *wnd,int id, intptr_t param){
	switch(id){
	case IDC_FUZZYSET:
		HmJre::RegEx().OptionDialog(wnd->GetHWND());
		return true;

	case IDOK:
		m_rv.CaseSense = ablib::window::CheckBox(wnd,IDC_CASESENSE).GetCheck();
		WriteINIInt(_T("Search"),_T("CaseSense"),ablib::window::CheckBox(wnd,IDC_CASESENSE).GetCheck() != false);
		m_rv.word = ablib::window::CheckBox(wnd,IDC_WORD).GetCheck();
		WriteINIInt(_T("Search"),_T("word"),ablib::window::CheckBox(wnd,IDC_WORD).GetCheck() != false);
		m_rv.fuzzy = ablib::window::CheckBox(wnd,IDC_FUZZY).GetCheck();
		WriteINIInt(_T("Search"),_T("Fuzzy"),ablib::window::CheckBox(wnd,IDC_FUZZY).GetCheck() != false);
		m_rv.use_regular = ablib::window::CheckBox(wnd,IDC_REGEX).GetCheck();
		WriteINIInt(_T("Search"),_T("RegEx"),ablib::window::CheckBox(wnd,IDC_REGEX).GetCheck() != false);
		m_rv.search = ablib::window::Combo(wnd,IDC_SEARCHTEXT).GetText();
		if(m_rv.search != _T(""))AddHistory(m_rv.search);
		if(m_UseSiborikomi){
			m_rv.Siborikomi = ablib::window::CheckBox(wnd,IDC_SIBORIKOMI).GetCheck();
//			WriteINIInt(_T("Search"),_T("Siborikomi"),ablib::window::CheckBox(wnd,IDC_SIBORIKOMI).GetCheck() != false);
		}
		wnd->Destroy(TRUE);
		return true;
		
	case IDCANCEL:
		wnd->Destroy(FALSE);
		return true;

	default:
		return false;
	}
}

bool BibTeX::SearchDialog::SearchStr::OnKey(ablib::window::Dialog *wnd,bool isDown,UINT vk, intptr_t repeat){
	if(vk == VK_UP || vk == VK_DOWN)ablib::window::Combo(wnd->GetParent()).ShowDropDown(true);
	else ablib::window::Combo(wnd->GetParent()).ShowDropDown(false);
	return false;
}

ablib::string BibTeX::SearchDialog::GetHistory(int n){
	ablib::string key = _T("History_") + ablib::lexical_cast<ablib::string>(n);
	TCHAR buf[4096];
	::GetPrivateProfileString(_T("Search"),key.c_str(),_T(""),buf,4095,m_ini.c_str());
	return ablib::string(buf);
}

void BibTeX::SearchDialog::AddHistory(const ablib::string &str){
	ablib::string key;
	TCHAR buf[4096];
	std::vector<ablib::string> hists;
	int i;
	for(i = 0 ; i < 20 ; ++i){
		key = _T("History_") + ablib::lexical_cast<ablib::string>(i);
		::GetPrivateProfileString(_T("Search"),key.c_str(),_T(""),buf,4095,m_ini.c_str());
		hists.push_back(buf);

		if(str == buf || ::lstrcmp(buf,_T("")) == 0)break;
	}
	++i;
	key = _T("History_0");
	::WritePrivateProfileString(_T("Search"),key.c_str(),str.c_str(),m_ini.c_str());
	for(int j = 1 ; j < i ; ++j){
		key = _T("History_") + ablib::lexical_cast<ablib::string>(j);
		::WritePrivateProfileString(_T("Search"),key.c_str(),hists[j - 1].c_str(),m_ini.c_str());
	}
	if(::lstrcmp(buf,_T("")) == 0){
		ablib::string key = _T("History_") + ablib::lexical_cast<ablib::string>(i);
		::WritePrivateProfileString(_T("Search"),key.c_str(),_T(""),m_ini.c_str());
	}
}

BibTeX::SearchDialog::SearchDialog() : BaseModalDlg(g_dllint){}

bool BibTeX::OnInitDialog(ablib::window::Dialog *wnd){
	wnd->SetTitle(_T("BibTeXf[^x[X"));
	ablib::window::ListView list(wnd,IDC_RESULTLIST);
	list.EnableFullRowSelect();
	std::vector<ablib::window::ListView::ColumnData> cdata;
	cdata.push_back(ablib::window::ListView::ColumnData(std::max(80,GetINIInt(_T("SearchResult"),_T("listwidth0"))),_T("x")));
//	cdata.push_back(ablib::window::ListView::ColumnData(100,_T("")));
	cdata.push_back(ablib::window::ListView::ColumnData(std::max(180,GetINIInt(_T("SearchResult"),_T("listwidth1"))),_T("")));
	cdata.push_back(ablib::window::ListView::ColumnData(std::max(600,GetINIInt(_T("SearchResult"),_T("listwidth2"))),_T("^Cg")));
	list.SetColumn(cdata);
	std::vector<ablib::string> data;
	for(std::vector<BibDATA>::size_type i = 0 ; i < m_showdata.size() ; ++i){
		data.clear();
		data.push_back(m_showdata[i].label);
//		data.push_back(m_showdata[i].bunrui);
		data.push_back(m_showdata[i].author);
		data.push_back(m_showdata[i].title);
		list.AddItem(data);
	}

	HDC hdc = ::GetWindowDC(wnd->GetHWND());
	RECT r;::GetClientRect(wnd->GetHWND(),&r);
	r.left = r.right - ::GetSystemMetrics(SM_CXHSCROLL);
	r.top = r.bottom - ::GetSystemMetrics(SM_CYVSCROLL);
	::DrawFrameControl(hdc,&r,DFC_SCROLL,DFCS_SCROLLSIZEGRIP);
	OUTPUTLASTERROR();
	::ReleaseDC(wnd->GetHWND(),hdc);

	ablib::window::Rect rc = wnd->GetRect();
	int iniint = GetINIInt(_T("SearchResult"),_T("width"));
	if(iniint >= MIN_WIDTH)rc.right = rc.left + iniint;
	iniint = GetINIInt(_T("SearchResult"),_T("height"));
	if(iniint >= MIN_HEIGHT)rc.bottom = rc.top + iniint;
	wnd->Move(rc);
	rc = wnd->GetClientRect();
	OnSize(wnd,0,rc.right - rc.left,rc.bottom - rc.top);

	return true;
}

bool BibTeX::OnCommand(ablib::window::Dialog *wnd,int id, intptr_t param){
	switch(id){
	case IDC_SEARCH:
	{
		SearchDialog sd;
		if(sd.CreateDlg(wnd,m_ini,true)){
			std::vector<BibDATA> d;
			if(sd.GetResult().Siborikomi)d = m_showdata;
			else d = m_data;
			HmJre::RegEx reg;
			reg.SetOpt(_T("CaseSense"),sd.GetResult().CaseSense);reg.SetOpt(_T("aimai"),sd.GetResult().fuzzy);
			reg.SetOpt(_T("use_regular"),sd.GetResult().use_regular);reg.SetOpt(_T("word"),sd.GetResult().word);
			if(reg.Compile(sd.GetResult().search)){
				m_showdata.clear();
				for(std::vector<BibDATA>::size_type i = 0 ; i < d.size() ; ++i){
					if(reg.Match(d[i].searchstr))m_showdata.push_back(d[i]);
				}
				ablib::window::ListView list(wnd,IDC_RESULTLIST);
				list.DeleteAllItems();
				for(std::vector<BibDATA>::size_type i = 0 ; i < m_showdata.size() ; ++i){
					std::vector<ablib::string> data;
					data.push_back(m_showdata[i].label);
					data.push_back(m_showdata[i].author);
					data.push_back(m_showdata[i].title);
					list.AddItem(data);
				}
			}else wnd->MsgBox(_T("sȓ͂łD"),_T("j"));
		}
		return true;
	}
	case IDOK:
	{
		ablib::window::ListView list(wnd, IDC_RESULTLIST);
		std::vector<ablib::string> result;
		int item = -1;
		m_rv = _T("");
		while ((item = ListView_GetNextItem(list.GetHWND(), item, LVNI_ALL | LVNI_SELECTED)) != -1) {
			if (m_rv == _T(""))m_rv = list.GetItem(item)[0];
			else m_rv += _T(",") + list.GetItem(item)[0];
		}
		wnd->Destroy(TRUE);
		return true;
	}
	case IDCANCEL:
		m_rv = _T("");
		wnd->Destroy(FALSE);
		return true;

	default:
		return false;
	}
}

bool BibTeX::OnDestroy(ablib::window::Dialog *wnd){
	ablib::window::Rect rect = wnd->GetRect();
	WriteINIInt(_T("SearchResult"),_T("width"),rect.right - rect.left);
	WriteINIInt(_T("SearchResult"),_T("height"),rect.bottom - rect.top);
	ablib::window::ListView list(wnd,IDC_RESULTLIST);
	for(int i = 0 ; i < list.GetColumnCount() ; ++i){
		WriteINIInt(_T("SearchResult"),(_T("listwidth") + ablib::lexical_cast<ablib::string>(i)).c_str(),list.GetColumnWidth(i));
	}
	return false;
}

bool BibTeX::OnSize(ablib::window::Dialog *wnd, intptr_t sw, intptr_t width, intptr_t height){
	ablib::window::ListView list = ablib::window::ListView(wnd,IDC_RESULTLIST);
	ablib::window::Dialog btnok = ablib::window::Dialog(wnd,IDOK);
	ablib::window::Dialog btncan = ablib::window::Dialog(wnd,IDCANCEL);
	ablib::window::Dialog btnsearch = ablib::window::Dialog(wnd,IDC_SEARCH);

	ablib::window::Point lt;ablib::window::Size size;
	ablib::window::Rect okrc = btnok.GetRect();
	ablib::window::Rect canrc = btncan.GetRect();
	ablib::window::Rect searchrc = btnsearch.GetRect();

	intptr_t okbtnx;

	list.Move(ablib::window::Point(0,0),ablib::window::Size(width,height - 2*(okrc.bottom - okrc.top)));
	lt.x = okrc.left;lt.y = okrc.top;lt = wnd->ScreenToClient(lt);
	okbtnx = lt.x;
	lt.y = height - (3*(okrc.bottom - okrc.top)/2);
	btnok.Move(lt,ablib::window::Size(okrc.right - okrc.left,okrc.bottom - okrc.top));

	lt.x = 2*okbtnx + okrc.right - okrc.left;lt.y = height - (3*(okrc.bottom - okrc.top)/2);
	btncan.Move(lt,ablib::window::Size(canrc.right - canrc.left,okrc.bottom - okrc.top));

	lt.x = width - (searchrc.right - searchrc.left) - okbtnx;
	lt.y = height - (3*(okrc.bottom - okrc.top)/2);
	btnsearch.Move(lt,ablib::window::Size(searchrc.right - searchrc.left,okrc.bottom - okrc.top));

	return true;
}

INT_PTR BibTeX::OnOtherMessage(ablib::window::Dialog *wnd,UINT msg,WPARAM wParam,LPARAM lParam){
	switch(msg){
	case WM_SIZING:
	{
		// l͓K
		RECT *rc = reinterpret_cast<RECT*>(lParam);
		INT_PTR rv = FALSE;
		if(rc->right - rc->left < MIN_WIDTH){
			if(wParam == WMSZ_LEFT || wParam == WMSZ_TOPLEFT || wParam == WMSZ_BOTTOMLEFT){
				rc->left = rc->right - MIN_WIDTH;
			}else rc->right = rc->left + MIN_WIDTH;
			rv = TRUE;
		}
		if(rc->bottom - rc->top < MIN_HEIGHT){
			if(wParam == WMSZ_TOP || wParam == WMSZ_TOPLEFT || wParam == WMSZ_TOPRIGHT){
				rc->top = rc->bottom - MIN_HEIGHT;
			}else rc->bottom = rc->top + MIN_HEIGHT;
			rv = TRUE;
		}
		return rv;
	}

	case WM_NOTIFY:
	{
		switch(reinterpret_cast<LPNMHDR>(lParam)->code){
		case NM_DBLCLK:
		{
			ablib::window::ListView list(wnd,IDC_RESULTLIST);
			int sel = list.GetCurSel();
			if(sel < 0)return FALSE;
			else m_rv = list.GetItem(sel)[0];
			wnd->Destroy(TRUE);
			return TRUE;
		}
		default:
			return FALSE;
		}
	}
/*	case WM_DRAWITEM:
	{
		DRAWITEMSTRUCT *dis = reinterpret_cast<LPDRAWITEMSTRUCT>(lParam);
		RECT rc;::GetWindowRect(wnd->GetHWND(),&rc);
		rc.left = rc.right - ::GetSystemMetrics(SM_CXHSCROLL);
		rc.top = rc.bottom - ::GetSystemMetrics(SM_CYVSCROLL);
		::DrawFrameControl(dis->hDC,&rc,DFC_SCROLL,DFCS_SCROLLSIZEGRIP);
		OUTPUTLASTERROR();
		return TRUE;
	}
*/	default:
		return FALSE;
	}
}

