#ifndef __BIBTEX_H__
#define __BIBTEX_H__

#include <vector>
#include <window/BaseModalDlg.h>
#include <ablib/lexical_cast.h>
#include <HmJre_dll/RegEx.h>
#include "resource.h"
/*
#pragma warning(disable:4005)
#include <boost/spirit/include/qi.hpp>
#pragma warning(default:4005)
*/

class TeXProject;

class BibTeX : public ablib::window::BaseModalDlg
{
public:
	BibTeX();
	~BibTeX(){}
	// .bib󔒂ŋ؂ƂCԂƂdlD
	// TeXProject̕kpsewhichɂĂD
	ablib::string CreateList(const ablib::string &f);
	void ListClear(){m_bibfiles.clear();}

	struct BibDATA{
		BibDATA(const ablib::string &a,const ablib::string &t,const ablib::string &l)
			: author(a),title(t),label(l){}
		BibDATA(){}
		void clear(){author = title = label = bunrui = _T("");}
		ablib::string author;
		ablib::string title;
		ablib::string note;
		ablib::string label;
		ablib::string bunrui;
		
		ablib::string searchstr;
		void CreateSearchStr();
	};

	intptr_t AnalyzeBib(bool clsresult = true){
		if(clsresult)m_data.clear();
		intptr_t rv = 0;
		for(std::vector<ablib::string>::size_type i = 0 ; i < m_bibfiles.size() ; ++i){
			rv += AnalyzeBib(m_bibfiles[i],false);
		}
		return rv;
	}
	intptr_t AnalyzeBib(const ablib::string &file,bool clsresult = true);
	void ToFile(const TCHAR *label,const TCHAR *other);

	intptr_t SearchDlg(HWND hwnd,const TCHAR *ini);

	const TCHAR *ShowResult(HWND hwnd,const TCHAR *ini);

private:
	class SearchDialog : public ablib::window::BaseModalDlg{
	public:
		struct SearchData{
			bool CaseSense;
			bool Siborikomi;
			bool word;
			bool use_regular;
			bool fuzzy;
			ablib::string search;
		};
		SearchData GetResult() const{return m_rv;}
		SearchDialog();
		~SearchDialog(){}
		intptr_t CreateDlg(ablib::window::Wnd *w,const ablib::string &ini,bool UseSiborikomi/*ui荞݌v\邩*/){
			m_ini = ini;
			m_UseSiborikomi = UseSiborikomi;
			return BaseModalDlg::Create(w,UseSiborikomi ? IDD_SEARCH2 : IDD_SEARCH);
		}
	private:
		bool OnInitDialog(ablib::window::Dialog *wnd);
		bool OnCommand(ablib::window::Dialog *wnd,int id, intptr_t param);
		SearchData m_rv;
		ablib::string m_ini;
		bool m_UseSiborikomi;
		ablib::string GetHistory(int n);
		void AddHistory(const ablib::string &str);
		int GetINIInt(const TCHAR *sec,const TCHAR *key){
			return ::GetPrivateProfileInt(sec,key,0,m_ini.c_str());
		}
		void WriteINIInt(const TCHAR *sec,const TCHAR *key, intptr_t val){
			::WritePrivateProfileString(sec,key,ablib::lexical_cast<ablib::string>(val).c_str(),m_ini.c_str());
		}
		class SearchStr : public ablib::window::SubClassDlg{
			bool OnKey(ablib::window::Dialog *wnd,bool isDown,UINT vk, intptr_t repeat);
		}m_sstr;
	};


private:
	std::vector<ablib::string> m_bibfiles;
	std::vector<BibDATA> m_data,m_showdata;

	bool CheckBunrui(const ablib::string &b);
	void UnEscape(ablib::string &str);

	friend class TeXProject;


	// ȉC_CAO֘A
	bool OnInitDialog(ablib::window::Dialog *wnd);
	bool OnCommand(ablib::window::Dialog *wnd,int id, intptr_t param);
	bool OnSize(ablib::window::Dialog *wnd, intptr_t sw,intptr_t width, intptr_t height);
	bool OnDestroy(ablib::window::Dialog *wnd);
	INT_PTR OnOtherMessage(ablib::window::Dialog *wnd,UINT msg,WPARAM wParam,LPARAM lParam);
	ablib::string m_rv,m_ini;
	static const int MIN_WIDTH = 400;
	static const int MIN_HEIGHT = 200;

	int GetINIInt(const TCHAR *sec,const TCHAR *key){
		return ::GetPrivateProfileInt(sec,key,0,m_ini.c_str());
	}
	void WriteINIInt(const TCHAR *sec,const TCHAR *key,intptr_t val){
		::WritePrivateProfileString(sec,key,ablib::lexical_cast<ablib::string>(val).c_str(),m_ini.c_str());
	}

};

#endif //__BIBTEX_H__

