#include "stdafx.h"
#include <hmjre_dll/RegEx.h>
#include <ablib/textfile.h>
#include <ablib/IsKanji.h>
#include <ablib/KRSearch.h>
#include "func.h"
#include "collectstr.h"

const size_t ONETIME_FIND = 2048;

intptr_t CollectStr::Set(const TCHAR *set,const TCHAR *val){
#define SETVAL(s) if(::lstrcmpi(set,_T( #s )) == 0){m_set. ## s = val;;return TRUE;}
	SETVAL(output);
	SETVAL(comment);
#undef SETVAL
	return FALSE;
}

intptr_t CollectStr::SetOpt(const TCHAR *set, intptr_t val){
	return m_regexp.SetOpt(set,val?true:false) ? TRUE : FALSE;
}


intptr_t CollectStr::Collect(const TCHAR *fname, const TCHAR *reg, const TCHAR *getstr) {
	FILE *fout, *comment;
	ablib::TextFile fin;
	TCHAR str[4 * ONETIME_FIND + 1];
	const TCHAR *p;
	ablib::string tostr, target;
	intptr_t rv = 0;
	size_t readsize;
	p = reg;
	if(m_set.output == _T(""))fout = NULL;
	else fout = ::_tfopen(m_set.output.c_str(), _T("a+"));
	if(m_set.comment == _T(""))comment = NULL;
	else comment = ::_tfopen(m_set.comment.c_str(), _T("a+"));
	if(!m_regexp.Compile(reg)) {
		SetmacrodllLastError(_T("K\̃RpCɎsD"));
		if(fout)::fclose(fout);
		if(comment)::fclose(comment);
		return -1;
	}
	if(IsNormalFile(fname))fin.Open(fname, ablib::TextFile::read);
	target = _T("");
	if(!fin)rv = LineSearch(fname, getstr, fout, comment);
	else if(ablib::KRSearch::strstr(reg, _T("\n"))) {
		CollectData cd;
		//K\s܂ށ`s̑I
		//ONETIME_FIND*4obt@ɋlߍ݁Aɑ΂sB
		readsize = fin.Read(str, 4 * ONETIME_FIND);
		str[readsize] = '\0';
		target = str;
		TCHAR match[4 * ONETIME_FIND + 1];
		::lstrcpy(match, _T(""));
		while(true) {
			::lstrcpy(match, target.c_str());
			if(m_regexp.Match(target.c_str())) {
				::lstrcpy(match, m_regexp.GetMatchStr(getstr));
				if(fout)::_ftprintf(fout, _T("%s"), match);
				else {
					cd.str = match;
					m_collectdata.push_back(cd);
				}
				target.erase(0, m_regexp.GetMatchPos() + m_regexp.GetMatchLen());
				readsize = fin.Read(str, 4 * ONETIME_FIND - target.length());
				str[readsize] = '\0';
				target += str;
				++rv;
			} else {
				readsize = fin.Read(str, ONETIME_FIND);
				if(readsize == 0)break;
				str[readsize] = '\0';
				target.erase(0, ONETIME_FIND);
				target += str;
			}
		}
	} else {
		int line = 1;
		// list̕D債TCYȂǂłD
		std::vector<ablib::string> coms;
		coms.reserve(COMMENTLINES * 2 + 1);
		for(int i = 0; i < COMMENTLINES; ++i) {
			if(fin.ReadLine(str, 4096)) {
				coms.push_back(str);
			} else break;
		}

		while(fin.ReadLine(str, 4096)) {
			if(coms.size() > 2 * COMMENTLINES)coms.erase(coms.begin(), coms.begin() + 1);
			coms.push_back(str);
			rv += LineSearch(coms[coms.size() - COMMENTLINES - 1].c_str(), getstr, fout, comment, coms, line);
			++line;
		}

		// c̕T[`Di͌Ă镶̌ɎcĂ鐔D
		for(intptr_t i = Min<intptr_t>(COMMENTLINES - 1, coms.size() - 1); i >= 0; --i) {
			if(coms.size() - i - 1 > COMMENTLINES)coms.erase(coms.begin(), coms.begin() + 1);
			rv += LineSearch(coms[coms.size() - i - 1].c_str(), getstr, fout, comment, coms, line);
			++line;
		}
	}
	if(fin)fin.Close();
	if(fout)::fclose(fout);
	if(comment)::fclose(comment);
	return rv;
}

intptr_t CollectStr::LineSearch(const TCHAR *str,const TCHAR *getstr,FILE *fout,FILE *comment,const std::vector<ablib::string> &writes, intptr_t line){
	CollectData cd;
	intptr_t rv = 0;
	const TCHAR *p = str;
	ablib::string match;
	ablib::string w;
	while(m_regexp.Match(p)){
		intptr_t pos = m_regexp.GetMatchPos(),len = m_regexp.GetMatchLen();
		p += m_regexp.GetMatchPos() + m_regexp.GetMatchLen();
		match = m_regexp.GetMatchStr(getstr);
		const TCHAR *q = m_regexp.GetMatchStr(getstr);
		if(writes.empty()){
			w = str;
		}else{
			w = _T("");
			for(std::vector<ablib::string>::const_iterator i = writes.begin() ; i != writes.end() ; ++i){
				w += *i;
			}
		}
		if(w != _T("") && w[w.length() - 1] == '\n')w.erase(w.length() - 1);
		UnEscape(w);
		if(comment){
			w += _T("\n");
			::_ftprintf(comment,_T("%s"),w.c_str());
		} else cd.comment = w;
		if(fout)::_ftprintf(fout,_T("%s"),match.c_str());
		else{
			cd.str = match;
			cd.line = line;
			m_collectdata.push_back(cd);
		}
		++rv;
	}
	return rv;
}

void CollectStr::UnEscape(ablib::string &str){
	ablib::string rv;
	rv.reserve(str.length() + 30);
	ablib::string::size_type p = 0;
	for(ablib::string::size_type i = 0 ; i < str.length() ; ++i){
		if(str[i] == '\\'){
			rv.append(str,p,i - p);
			p = i + 1;
			rv += _T("\\\\");
		}else if(str[i] == '\n'){
			rv.append(str,p,i - p);
			p = i + 1;
			rv += _T("\\n");
		}
#ifndef UNICODE
		else if(ablib::IsKanji(str[i]))++i;
#endif
	}
	rv.append(str,p,ablib::string::npos);
	str = rv;
}


const TCHAR *CollectStr::GetStr(intptr_t i){
	if(i < 0 || i >= m_collectdata.size())return _T("");
	return m_collectdata[i].str.c_str();
}

const TCHAR *CollectStr::GetComment(intptr_t i){
	if(i < 0 || i >= m_collectdata.size())return _T("");
	return m_collectdata[i].comment.c_str();
}

intptr_t CollectStr::GetLine(intptr_t i){
	if(i < 0 || i >= m_collectdata.size())return 0;
	return m_collectdata[i].line;
}