#include "stdafx.h"
#include <stdio.h>
#include <ablib/IsKanji.h>
#include <system/Process.h>
#include <ablib/SmallBuffer.h>
#include "version.h"
#include "compile.h"
#include "Env.h"

#ifdef NDEBUG
#define DUMP(s)
#else
#define DUMP(s) Dump(s)
#endif

Compile::Compile() : m_width(0), m_height(0),m_charcode(0){
	m_edit.m_color = ::GetSysColor(COLOR_WINDOW);
	m_edit.SetParent(this);
}

intptr_t Compile::Set(const TCHAR *set, const TCHAR *val){
#define SET(s) if(::lstrcmp(_T( #s ) , set) == 0){m_set. ## s = val;return TRUE;}
	SET(log);
	SET(title);
	SET(message);
#undef SET
	return FALSE;
}

intptr_t Compile::SetEnv(const TCHAR *name, const TCHAR *val) {
	ENV env(name, val);
	if (std::find(m_envs.begin(), m_envs.end(), env) != m_envs.end()) {
		::SetmacrodllLastError(_T("łɐݒ肳ĂϐłD"));
		return FALSE;
	} else {
		m_envs.push_back(ENV(name, val));
		return TRUE;
	}
}

intptr_t Compile::Start(HWND hwnd, const TCHAR *command, const TCHAR *dir) {
	InitRichText rich;
	if (rich.IsNULL())return FALSE;

	m_rv = false;
	ablib::system::Process::ProcessStartInfo si;
	si.FileName = _T("");
	si.Arguments = command;
	si.WorkingDirectory = dir;
	si.RedirectStandardOutput = si.RedirectStandardError = si.RedirectStandardInput = true;
	si.CreateNoWindow = true; si.ShowState = ablib::system::Process::ProcessStartInfo::hide;
	m_process.StartInfo(si);

	HWND me = Create(hwnd);
	auto a = ::GetLastError();
	if (me == NULL) {
		::SetmacrodllLastError();
		return FALSE;
	}
	m_edit.AppendString(ablib::TransCode::Trans(m_set.message));
	m_edit.AppendString(L"COMMAND : ");
	m_edit.AppendString(ablib::TransCode::Trans(m_process.StartInfo().Arguments));
	m_edit.AppendString(L"\n\n");

	if (m_set.log != _T(""))m_logfp = ::_tfopen(m_set.log.c_str(), _T("a"));
	else m_logfp = NULL;

	if (m_logfp){
		ablib::SmallBuffer<char> cbuf;
		ablib::SmallBuffer<wchar_t> wbuf;
		auto len = ::lstrlen(command);
		wbuf.Alloc(static_cast<size_t>(::MultiByteToWideChar(CP_ACP, 0, command, len, NULL, 0)) + 2);
		int wlength = ::MultiByteToWideChar(CP_ACP, 0, command, (int)len, wbuf.buf, (int)wbuf.size - 1);
		wbuf.buf[wlength] = '\0';
		cbuf.Alloc(static_cast<size_t>(::WideCharToMultiByte(CP_UTF8, 0, wbuf.buf, wlength, NULL, 0, NULL, NULL)) + 1);
		auto clength = ::WideCharToMultiByte(CP_UTF8, 0, wbuf.buf, (int)wlength, cbuf.buf, (int)cbuf.size, NULL, NULL);
		cbuf.buf[clength] = '\0';
		::fprintf(m_logfp, _T("///////////////////////////////////////////////////\nCOMMAND : %s\n///////////////////////////////////////////////////\n"), cbuf.buf);
		::fprintf(m_logfp, _T("(Hidemaru macro version %s)\n\n"),VERSION_SHORTSTR);
	}

	::EnableWindow(hwnd, FALSE);
	SetActiveWindow();
	Read();
	if(m_logfp)::fclose(m_logfp);
	::EnableWindow(hwnd, TRUE);
	if(IsWindow())DestroyWindow();
	return m_rv ? TRUE : FALSE;
}

BOOL Compile::OnInitDialog(CWindow wndFocus, LPARAM lInitParam){
	m_edit.SubclassWindow(::GetDlgItem(m_hWnd,IDC_COMPILEEDIT));
	m_edit.m_rich = m_edit.m_hWnd;
	m_edit.Init();
	
	intptr_t height, width;
	if(m_width <= 0 || m_height <= 0) { width = CW_USEDEFAULT; height = 0; } else { width = m_width; height = m_height; }
	RECT rc;
	GetClientRect(&rc);
	RECT pos;
	if(m_x != CW_USEDEFAULT) { pos.left = (LONG)m_x; pos.top = (LONG)m_y; } else { pos.left = rc.left; pos.top = rc.top; }
	if(width != CW_USEDEFAULT) { pos.right = pos.left + (LONG)width; pos.bottom = pos.top + (LONG)height; } else { pos.right = rc.right - rc.left + pos.left; pos.bottom = rc.bottom - rc.top + pos.top; }
	MoveWindow(&pos);
	ShowWindow(SW_SHOW);
	SetWindowText(m_set.title.c_str());

	m_rv = Exec();
	return m_rv ? TRUE : FALSE;
}

void Compile::Edit::Init() {
	m_rich.SetBackgroundColor(m_back);
	if(m_fontname != "" || m_fontsize != 0) {
		if(!m_font.IsNull()) m_font.DeleteObject();
		m_font.CreateFont((int)m_fontsize, 0, 0, 0, FW_NORMAL, FALSE, FALSE, FALSE, DEFAULT_CHARSET, OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS, PROOF_QUALITY, FIXED_PITCH | FF_MODERN, m_fontname.c_str());
		if(!m_font.IsNull()) m_rich.SetFont(m_font.m_hFont);
	}
	CHARFORMAT2 chf;
	m_rich.GetDefaultCharFormat(chf);
	chf.crTextColor = m_color;
	chf.dwMask = CFM_COLOR;
	chf.dwEffects &= ~CFE_AUTOCOLOR;
	m_rich.SetDefaultCharFormat(chf);

	auto langopt = m_rich.SendMessage(EM_GETLANGOPTIONS, 0, 0);
	langopt &= ~IMF_AUTOFONT;
	m_rich.SendMessage(EM_SETLANGOPTIONS, 0, (LPARAM)langopt);
}

void Compile::OnSize(UINT nType, CSize size) {
	RECT rc;
	GetClientRect(&rc);
	m_edit.MoveWindow(&rc);
}

void Compile::OnSetFocus(CWindow wndOld) {
	m_edit.SetFocus();
}

void Compile::OnClose() {
	if(!m_process.HasExited()) {
		if(::MessageBox(m_hWnd, _T("qvZXsBI܂H"), _T("G["), MB_YESNO) == IDYES) {
			// vZXICvZXĎ[`wnd->Destroy()𔭂̂ŁC
			// ł̓vZXÊ݁D
			m_process.Kill();
		}
		return;
	}
	// ɂ邱Ƃ͎͂Ȃ͂D
	ASSERT(false);
	DestroyWindow();
}

void Compile::OnDestroy() {
	if(!m_process.HasExited())m_process.Kill();
}

bool Compile::Exec() {
	if(!m_process.HasExited())return false;

	Env env;
	for(auto e : m_envs) {
		env.Set(e.name.c_str(), e.value.c_str());
	}
	bool rv = m_process.Start();
	if(!rv)SetmacrodllLastError(ablib::system::GetLastError());
	env.Restore();

	return rv;
}


void Compile::Read() {
	Reader *reader;
	std::function<void(const char*, int, const char*, const wchar_t*)> f = [this](const char *obuf, int k, const char *b, const wchar_t *wb) {
		if (m_logfp) {
			// UTF=8
			ablib::SmallBuffer<char> cbuf;
			auto wlen = ::lstrlenW(wb);
			cbuf.Alloc(::WideCharToMultiByte(CP_UTF8, 0, wb, wlen, NULL, 0, NULL, NULL) + 1);
			auto len = ::WideCharToMultiByte(CP_UTF8, 0, wb, wlen, cbuf.buf, (int)cbuf.size + 1, NULL, NULL);
			::fwrite(cbuf.buf, sizeof(char), len, m_logfp);
		}
		m_edit.AppendString(wb, b);
	};
	switch(m_charcode) {
	case 2:reader = new UTF16LEReader(f); break;
	case 3:reader = new EUCJPReader(f); break;
	case 4:reader = new JISReader(f); break;
	case 5:reader = new UTF7Reader(f); break;
	case 6:reader = new UTF8Reader(f); break;
	case 7:reader = new UTF16BEReader(f); break;
	case 0:// VK
	case 1:// Shift_JIS
	default:reader = new SJISReader(f); break;
	}
	bool end = false;
	MSG msg;
	do {
		switch (m_process.WaitForMsg(20)) {
		case ablib::system::Process::message:
			// bZ[W[v񂵁cc΂ȁH
			while (::PeekMessage(&msg, 0, 0, 0, PM_REMOVE)) {
				::TranslateMessage(&msg);
				::DispatchMessage(&msg);
			}
			break;
		case ablib::system::Process::process_exit:
			end = true;
			break;
		default:
			break;
		}
		if(m_process.HasExited())end = true;
		while(DWORD readsize = reader->Read(&m_process));
	} while (!end);

	if (m_logfp)::_ftprintf(m_logfp, _T("\n\n"));

	return;
}

void Compile::Edit::AppendString(const wchar_t *wstr, const char *cstr) {
	if(IsWindow()) {
		if(m_str != L"") {
			AppendStringSub(m_str.c_str(), ablib::TransCode::Trans(m_str).c_str());
			m_str = L"";
		}
		AppendStringSub(wstr, cstr);
	} else {
		m_str += wstr;
	}
}

void Compile::Edit::AppendStringSub(const wchar_t *wstr, const char *cstr) {
	ablib::SmallBuffer<wchar_t> buf;
	if(!*wstr)return;
	m_rich.HideSelection(TRUE);
	// J[\ŌɈړ
	int len = m_rich.GetTextLengthEx(0, 1200);
	m_rich.SetSel(len, len);
	// }O̍ŏIs擾ĂDiFOj
	int startindex;
	if(cstr != NULL) {
		int startline = m_rich.GetLineCount() - 1;
		buf.Alloc(len + 3);
		*(LPWORD) buf.buf = (WORD) buf.size;
		auto count = ::SendMessageW(m_hWnd,EM_GETLINE, startline, (LPARAM) buf.buf);
		if(count >= 1 && buf.buf[count - 1] == '\r')--count;
		buf.buf[count] = '\0';
		startindex = m_rich.LineIndex(startline);
	}
	// }
	SETTEXTEX wp;
	wp.flags = ST_SELECTION; wp.codepage = 1200;
	::SendMessage(m_hWnd, EM_SETTEXTEX, (WPARAM) &wp, (LPARAM) wstr);
	// }OŏIs猻݂̍̕Ō܂ł擾Cɑ΂ănCCg
	// Fchar*CnCCgFwchar_t*Ȃ̂ŁCZKvD
	// vĂ̂ŖʂccD
	if(cstr != NULL) {
		ablib::cstring str;
		str = ablib::TransCode::Trans(buf.buf);
		bool end = false;
		int start = 0;
		// sƂɕď
		CHARFORMAT2 cf; ::ZeroMemory(&cf, sizeof(CHARFORMAT2));
		cf.dwMask = CFM_COLOR | CFM_BACKCOLOR | CFM_BOLD | CFM_ITALIC | CFM_UNDERLINE;
		while(!end) {
			int linelen1 = 0;//strRiŏj
			int linelen2 = 0;//cstrR
			int wlinelen = 0;
			for(; linelen1 < static_cast<int>(str.length()); linelen1 += ablib::IsKanji(str[linelen1]) ? 2 : 1)++wlinelen;
			for(; cstr[linelen2] != '\n' && cstr[linelen2] != '\0'; linelen2 += ablib::IsKanji(cstr[linelen2]) ? 2 : 1)++wlinelen;
			if(cstr[linelen2] == '\0')end = true;
			str.append(cstr, linelen2);
			for(auto h : m_hilight) {
				cf.crTextColor = h.color;
				cf.crBackColor = h.back;
				cf.dwEffects = (DWORD)h.style;
				/*
				std::wsregex_iterator ite(str.cbegin(), str.cend(), h.reg);
				std::wsregex_iterator end;
				for(; ite != end; ++ite) {
					for(auto pos : h.position) {
					if(pos > ite->size())break;
					m_rich.SetSel(startindex + ite->position(pos), startindex + ite->position(pos) + ite->length(pos));
					m_rich.SetSelectionCharFormat(cf);
					}
				}
				*/
				intptr_t start = 0, wstart = 0;
				while(h.reg->Match(str, (int)start)) {
					intptr_t cpos = h.reg->GetMatchPos();
					for(; start < cpos; start += ablib::IsKanji(str[start]) ? 2 : 1)++wstart;
					intptr_t clen = h.reg->GetMatchLen();
					intptr_t end = start, wend = wstart;
					for(; end < cpos + clen; end += ablib::IsKanji(str[end]) ? 2 : 1)++wend;
					for(auto tag : h.position) {
						intptr_t whstart, whend;
						if(tag == 0) {
							whstart = wstart;
							whend = wend;
						} else {
							intptr_t pos = h.reg->GetMatchPos(tag);
							intptr_t len = h.reg->GetMatchLen(tag);
							intptr_t hstart = start;
							whstart = wstart;
							for(; hstart < pos; hstart += ablib::IsKanji(str[hstart]) ? 2 : 1)++whstart;
							intptr_t hend = hstart;
							whend = whstart;
							for(; hend < pos + len; hend += ablib::IsKanji(str[hend]) ? 2 : 1)++whend;
						}
						m_rich.SetSel((LONG)(startindex + whstart), (LONG)(startindex + whend));
						m_rich.SetSelectionCharFormat(cf);
					}
					start = end;
					wstart = wend;
				}
			}
			cstr += linelen2 + 1;
			startindex += wlinelen + 1;
			str = "";
		}
	}
	// ŌɃJ[\ʒu߂ĂD
	len = m_rich.GetTextLengthEx(0, 1200);
	m_rich.SetSel(len, len);
	m_rich.HideSelection(FALSE);
}

void Compile::Edit::OnChar(TCHAR ch, UINT nRepCnt, UINT nFlags) {
	ablib::string::size_type n = m_keybuf.length();
	if(::GetKeyState(VK_CONTROL) < 0) {
		ch += 96;
		if(ch == 'c')m_rich.Copy();
		else if(ch == 'a') m_rich.SetSelAll();
	} else {
		if(ch == 0x08) {//BackSpace
			if(n != 0) {
				m_rich.HideSelection(TRUE);
				m_keybuf.erase(n - 1);
				int tlen = m_rich.GetTextLengthEx(GTL_DEFAULT, 1200);
				m_rich.SetSel(tlen - 1, tlen);
				SETTEXTEX wp;
				wp.flags = ST_SELECTION; wp.codepage = 1200;
				m_rich.SendMessage(EM_SETTEXTEX, (WPARAM) &wp, (LPARAM) L"");
				m_rich.HideSelection(FALSE);
			}
		} else if(ch == '\r') {//Return
			m_keybuf += _T("\n");
			m_parent->m_process.Write(m_keybuf.c_str(), (DWORD)m_keybuf.length());
			if(m_parent->m_logfp)::_ftprintf(m_parent->m_logfp, _T("%s"), m_keybuf.c_str());
			AppendString(L"\n");
			m_keybuf = _T("");
		} else if(ch == 27 || ch == 9 || ch == 28 || ch == 29 || ch == 30 || ch == 31) {//Esc,Tab,,,,
			return;
		} else if(ch < 127) {
			m_keybuf += ch;
			AppendString(ablib::TransCode::Trans(ablib::string(ch)));
		}
	}
}

void Compile::Edit::OnRButtonDown(UINT uFlags,  CPoint pt) {
	this->ClientToScreen(&pt);
	CMenu m;
	m.CreatePopupMenu();
	m.AppendMenu(MF_STRING, 1, _T("SđI"));
	m.AppendMenu(MF_STRING, 2, _T("Rs["));
	m.AppendMenu(MF_STRING, 3, _T("SăRs["));
	switch(m.TrackPopupMenu(TPM_RETURNCMD | TPM_NONOTIFY | TPM_LEFTBUTTON | TPM_LEFTALIGN | TPM_TOPALIGN, pt.x, pt.y, m_hWnd)) {
	case 1:
		m_rich.SetSelAll();
		return;
	case 2:
		m_rich.Copy();
		return;
	case 3:
	{
		CHARRANGE cr;
		m_rich.HideSelection(TRUE);
		m_rich.GetSel(cr);
		m_rich.SetSelAll();
		m_rich.Copy();
		m_rich.SetSel(cr);
		m_rich.HideSelection(FALSE);
		return;
	}
	default:
		return;
	}
}


namespace {
	enum CodeSet { ASCII, KANA, JIS };

	void jis2sjis(BYTE k, BYTE t, char *rv) {
		if(k >= 0x3f) rv[0] = (char) (((k + 1) >> 1) + 0xc0);
		else rv[0] = (char) (((k + 1) >> 1) + 0x80);
		if(k & 1) rv[1] = (char) ((t >> 6) ? t + 0x40 : t + 0x3f);
		else rv[1] = (char) (t + 0x9e);
	}

	int tosjis(CodeSet cs, const char *input, int &offset, char *rv) {
		BYTE c[2];
		switch (cs) {
		case ASCII:
			rv[0] = input[offset];
			++offset;
			return 1;
		case JIS:
			c[0] = input[offset]; c[1] = input[offset + 1];
			jis2sjis((c[0] & 0x7F) - 0x20, (c[1] & 0x7F) - 0x20, rv);
			offset += 2;
			return 2;
		case KANA:
			rv[0] = input[offset];
			++offset;
			return 1;
		default:
			return 0;
		}
	}
	
	void SJIS2UTF16(const ablib::SmallBuffer<char> &cbuf,int length,ablib::SmallBuffer<wchar_t> &wcbuf) {
		wcbuf.Alloc(::MultiByteToWideChar(CP_ACP,MB_PRECOMPOSED,cbuf.buf,length,NULL,0) + 1);
		auto size = ::MultiByteToWideChar(CP_ACP,MB_PRECOMPOSED,cbuf.buf,length,wcbuf.buf,(int)wcbuf.size);
		wcbuf.buf[size] = L'\0';
	}
	void UTF162SJIS(const ablib::SmallBuffer<wchar_t> &wcbuf,int length,ablib::SmallBuffer<char> &cbuf) {
		cbuf.Alloc(WideCharToMultiByte(CP_ACP,0,wcbuf.buf,length,NULL,0,NULL,NULL) + 1);
		auto size = ::WideCharToMultiByte(CP_ACP,0,wcbuf.buf,(int)length,cbuf.buf,(int)cbuf.size,NULL,NULL);
		cbuf.buf[size] = '\0';
	}

}

void Compile::SJISReader::ConvertCode(char *buf, int length, ablib::SmallBuffer<char> &cbuf, ablib::SmallBuffer<wchar_t> &wcbuf) {
	cbuf.Alloc(length + 1);
	::lstrcpynA(cbuf.buf, buf, length + 1);
	SJIS2UTF16(cbuf,length,wcbuf);
}

void Compile::EUCJPReader::ConvertCode(char *buf, int length, ablib::SmallBuffer<char> &cbuf, ablib::SmallBuffer<wchar_t> &wcbuf) {
	CodeSet G[] = {ASCII, JIS, KANA, JIS};
	const BYTE SS2 = 0x8E;
	const BYTE SS3 = 0x8F;
	cbuf.Alloc(length + 10);
	int writesize = 0;
	for(int i = 0; i < length;) {
		cbuf.Alloc(writesize + 2);
		switch(buf[i]) {
		case SS2:
			++i;
			writesize += tosjis(G[2], buf, i, cbuf.buf + writesize);
			break;
		case SS3:
			++i;
			writesize += tosjis(G[3], buf, i, cbuf.buf + writesize);
			break;
		default:
			if(buf[i] < 0) {
				writesize += tosjis(G[1], buf, i, cbuf.buf + writesize);
			} else {
				writesize += tosjis(G[0], buf, i, cbuf.buf + writesize);
			}
			break;
		}
	}
	cbuf.buf[writesize] = '\0';
	SJIS2UTF16(cbuf,writesize,wcbuf);
	return;
}

void Compile::JISReader::ConvertCode(char *buf, int length, ablib::SmallBuffer<char> &cbuf, ablib::SmallBuffer<wchar_t> &wcbuf) {
	const int ESC = 0x1B;
	CodeSet G0 = ASCII;
	cbuf.Alloc(length + 10);
	int writesize = 0;
	for(int i = 0; i < length;) {
		cbuf.Alloc(writesize + 2);
		switch(buf[i]) {
		case ESC:
			++i;
			if(buf[i] == '(') {
				if(buf[i + 1] == 'B' || buf[i + 1] == 'J')G0 = ASCII;
			} else if(buf[i] == '$') {
				if(buf[i + 1] == '@' || buf[i + 1] == 'B')G0 = JIS;
			}
			i += 2;
			break;
		case '\n':
			G0 = ASCII;
			cbuf.buf[writesize] = '\n';
			++writesize; ++i;
			break;
		default:
			writesize += tosjis(G0, buf, i, cbuf.buf + writesize);
			break;
		}
	}
	cbuf.buf[writesize] = '\0';
	SJIS2UTF16(cbuf,writesize,wcbuf);
	return;
}

void Compile::UTF16BEReader::ConvertCode(wchar_t *buf, int length, ablib::SmallBuffer<char> &cbuf, ablib::SmallBuffer<wchar_t> &wcbuf) {
	wcbuf.Alloc(length);
	for(int i = 0; i < length; ++i){
		wcbuf.buf[i] = static_cast<wchar_t>((buf[i] & 0x00FF) << 8 | (buf[i] & 0xFF00) >> 8);
	}
	UTF162SJIS(wcbuf,length,cbuf);
}

void Compile::UTF16LEReader::ConvertCode(wchar_t *buf, int length, ablib::SmallBuffer<char> &cbuf, ablib::SmallBuffer<wchar_t> &wcbuf) {
	wcbuf.Alloc(length + 1);
	::lstrcpynW(wcbuf.buf,buf,length + 1);
	UTF162SJIS(wcbuf,length,cbuf);
}

/*
#ifndef NDEBUG
void Compile::Dump(const CharBuf<char> &b) {
	for (int i = 0; i < b.size && b.buf[i]; ++i) {
		if (b.buf[i] == '\r')DEBUGSTRING("i = %d, \\r", i);
		else if (b.buf[i] == '\n')DEBUGSTRING("i = %d, \\n", i);
	}
}
#endif
*/
