#ifndef __COMPILE_H__
#define __COMPILE_H__

/** RpCp̉ʂ
*/
#include <system/Process.h>
#include <vector>
#include <functional>
template<typename T> T max(T a,T b){if(a > b)return a;else return b;}
template<typename T> T min(T a,T b){if(a < b)return a;else return b;}
#include <atlmisc.h>
#include <atlctrls.h>
#include <memory>
#include <hmjre_dll/RegEx.h>
#include <ablib/SmallBuffer.h>
#include <ablib/IsKanji.h>
#include "resource.h"

class Compile : public CDialogImpl < Compile > {
public:
	enum { IDD = IDD_COMPILE };

	Compile();
	~Compile() {}	
	intptr_t Set(const TCHAR *set, const TCHAR *val);
	intptr_t SetEnv(const TCHAR *name, const TCHAR *val);
	intptr_t ClearEnv() { m_envs.clear(); return TRUE; }
	intptr_t SetSize(intptr_t width, intptr_t height) { m_width = width; m_height = height; return TRUE; }
	intptr_t SetPos(intptr_t x, intptr_t y) { m_x = x; m_y = y; return TRUE; }
	intptr_t SetFont(const TCHAR *font, intptr_t size) {
		m_edit.m_fontname = font;
		m_edit.m_fontsize = size;
		return TRUE;
	}
	intptr_t Start(HWND hwnd, const TCHAR *command, const TCHAR *dir);
	intptr_t AddHilight(const TCHAR *keyword, intptr_t opt, intptr_t pos, intptr_t color, intptr_t back, intptr_t style) {
		return m_edit.AddHilight(keyword, opt, pos, (COLORREF)color, (COLORREF)back, style);
	}
	intptr_t ClearHilight() { return m_edit.ClearHilight(); }
	intptr_t SetColor(intptr_t color, intptr_t back) {
		m_edit.m_color = (COLORREF)color;
		m_edit.m_back = (COLORREF)back;
		return TRUE;
	}
	intptr_t GetExitCode() { return m_process.ExitCode(); }
	void SetCode(intptr_t code) { m_charcode = code; }
private:
	intptr_t m_charcode;

	struct ENV {
		ENV() {};
		ENV(const TCHAR *n, const TCHAR *v) : name(n), value(v) {};
		ablib::string name;
		ablib::string value;
		bool operator==(const ENV &obj) { return (name == obj.name && value == obj.value); }
	};
	struct COMPILESET {
		ablib::string log;
		ablib::string title;
		ablib::string titlebar;
		ablib::string message;
	}m_set;

	ablib::system::Process m_process;
	bool m_rv;
	std::vector<ENV> m_envs;
	FILE *m_logfp;

	intptr_t m_width, m_height, m_x, m_y;

	class InitRichText {
	private:
		HINSTANCE hRich;
	public:
		InitRichText() {
			hRich = LoadLibrary(CRichEditCtrl::GetLibraryName());
			if(hRich == NULL)::SetmacrodllLastError(_T("RichTextEditControl̏Ɏs"));
		}
		~InitRichText() {
			::FreeLibrary(hRich);
		}
		bool IsNULL() { return hRich == NULL; }
	};


	bool Exec();
	void Read();

	BEGIN_MSG_MAP_EX(Compile)
		MSG_WM_INITDIALOG(OnInitDialog)
		MSG_WM_SIZE(OnSize)
		MSG_WM_SETFOCUS(OnSetFocus)
		MSG_WM_CLOSE(OnClose)
		MSG_WM_DESTROY(OnDestroy)
	END_MSG_MAP()

	BOOL OnInitDialog(CWindow wndFocus, LPARAM lInitParam);
	void OnSize(UINT nType, CSize size);
	void OnSetFocus(CWindow wndOld);
	void OnClose();
	void OnDestroy();

	class Edit : public CWindowImpl < Edit > {
	public:
		int AddHilight(const TCHAR *keyword, intptr_t opt, intptr_t pos, COLORREF color, COLORREF back, intptr_t style) {
			try {
				Edit::Hilight hilight(keyword, opt, pos, color, back, style);
				m_hilight.push_back(hilight);
				return TRUE;
			} catch(...) {
				SetmacrodllLastError(ablib::string(keyword) + _T(" ͕sȐK\łD"));
				return FALSE;
			}
		}
		int ClearHilight() {
			m_hilight.clear();
			return TRUE;
		}
		ablib::string m_fontname;
		intptr_t m_fontsize = 0;
		COLORREF m_color = RGB(0, 0, 0), m_back = RGB(255, 255, 255);
		void AppendString(const ablib::wstring &wstr) { AppendString(wstr.c_str()); }
		void AppendString(const wchar_t *wstr, const char*cstr = NULL);
		void AppendStringSub(const wchar_t *wstr, const char*cstr = NULL);
		void SetParent(Compile *p) { m_parent = p; }
		void Init();
		CRichEditCtrl m_rich;
	private:
		struct Hilight {
			Hilight(const TCHAR *key, intptr_t opt, intptr_t pos, COLORREF col, COLORREF bac, intptr_t s)
				: //reg(ablib::TransCode::Trans(key), std::regex::ECMAScript | std::regex::optimize | ( ( pos & 0x10 ) ? std::regex::ECMAScript : std::regex::icase )),
				reg(new HmJre::RegEx()),
				color(col), back(bac), style(s) {
				reg->SetOpt("word", (opt & 1) ? TRUE : FALSE);
				reg->SetOpt("CaseSense", (opt & 2) ? TRUE : FALSE);
				if(!reg->Compile(key))throw std::exception();
				if(pos != 0) {
					for(int i = 0; i < 10; ++i) {
						if((pos >> i) & 0x1)position.push_back(i);
					}
				} else position.push_back(0);
			}
			std::vector<int> position;
			COLORREF color, back;
			intptr_t style;
			//std::wregex reg;
			std::shared_ptr<HmJre::RegEx> reg;
		};
		std::vector<Hilight> m_hilight;

		BEGIN_MSG_MAP_EX(Edit)
			MSG_WM_CHAR(OnChar)
			MSG_WM_RBUTTONDOWN(OnRButtonDown)
			MSG_WM_KEYDOWN(OnKey)
			MSG_WM_KEYUP(OnKey)
		END_MSG_MAP()

		void OnChar(TCHAR nChar, UINT nRepCnt, UINT nFlags);
		void OnKey(UINT vk, UINT nRepCnt, UINT nFlags) {
			if(vk == VK_LEFT || vk == VK_RIGHT || vk == VK_UP || vk == VK_DOWN)SetMsgHandled(FALSE);
		}
		void OnRButtonDown(UINT uFlags, CPoint pt);
		ablib::string m_keybuf;
		Compile *m_parent;
		CFont m_font;
		ablib::wstring m_str;
	}m_edit;

	class Reader {
	public:
		virtual DWORD Read(ablib::system::Process *process) = 0;
	};

	template<typename CH, CH CR, CH LF> class base_Reader : public Reader {
	public:
		typedef std::function<void(const char*, int, const char*, const wchar_t*)> OutputFunction;
	private:
		CH buf[4096], ins[5000];
		int bufidx = 0;
		std::function<bool(CH)> iskanji;
		OutputFunction fun;
	public:
		base_Reader(std::function<bool(CH)> isk, OutputFunction f) : iskanji(isk), fun(f) {}
		virtual ~base_Reader() {}
		virtual void ConvertCode(CH *buf, int length, ablib::SmallBuffer<char> &cbuf, ablib::SmallBuffer<wchar_t> &wcbuf) = 0;
		DWORD Read(ablib::system::Process *process) {
			ablib::SmallBuffer<char> charbuf;
			ablib::SmallBuffer<wchar_t> wcharbuf;
			int i;
			DWORD rv = process->Read((char*) (buf + bufidx), 4093) / (sizeof(CH) / sizeof(char));
			DWORD readsize = rv + bufidx;
			if(readsize == 0)return 0;
			buf[readsize] = '\0';
			//ȉsR[hDsakura editorQlɂĂ܂iƂwǃRsyłDjD
			//\r\n,\r\nɕϊD
			int k = 0;
			for(i = 0; i < static_cast<int>(readsize) -1; ++i) {
				if(buf[i] == CR) {
					if(buf[i + 1] == LF)++i;
					ins[k++] = LF;
				} else if(iskanji(buf[i])) {
					ins[k++] = buf[i++]; ins[k++] = buf[i];
				} else {
					ins[k++] = buf[i];
				}
			}
			if(i == readsize - 1) {
				if(buf[i] == CR)i = readsize + 1;
				else if(iskanji(buf[i]))i = readsize + 1;
				else { ins[k++] = buf[i]; i = readsize; }
			}
			if(i == readsize)bufidx = 0;
			else {
				buf[0] = buf[readsize - 1];
				bufidx = 1;
			}
			ins[k] = '\0';
			ConvertCode(ins, k, charbuf, wcharbuf);
			fun(reinterpret_cast<const char*>(ins), k * sizeof(CH)/sizeof(char), charbuf.buf, wcharbuf.buf);
			return rv;
		}
	};

	struct SJISReader : public base_Reader < char, '\r', '\n' > {
		SJISReader(OutputFunction f) : base_Reader<char, '\r', '\n'>(ablib::IsKanji, f) {}
		void ConvertCode(char *buf, int length, ablib::SmallBuffer<char> &cbuf, ablib::SmallBuffer<wchar_t> &wcbuf);
	};
	struct EUCJPReader : public base_Reader < char, '\r', '\n' > {
		EUCJPReader(OutputFunction f) : base_Reader<char, '\r', '\n'>([] (char c) {return (c > 0x80); }, f) {}
		void ConvertCode(char *buf, int length, ablib::SmallBuffer<char> &cbuf, ablib::SmallBuffer<wchar_t> &wcbuf);
	};
	struct JISReader : public base_Reader < char, '\r', '\n' > {
		JISReader(OutputFunction f) : base_Reader<char, '\r', '\n'>([] (char) {return false; }, f) {}
		void ConvertCode(char *buf, int length, ablib::SmallBuffer<char> &cbuf, ablib::SmallBuffer<wchar_t> &wcbuf);
	};
	template<int CP> struct UTF78Reader_template : public base_Reader < char, '\r', '\n' > {
		UTF78Reader_template(OutputFunction f) : base_Reader<char, '\r', '\n'>([] (char) {return false; }, f) {}
		void ConvertCode(char *buf, int length, ablib::SmallBuffer<char> &cbuf, ablib::SmallBuffer<wchar_t> &wcbuf) {
			wcbuf.Alloc(::MultiByteToWideChar(CP, 0, buf, length, NULL, 0) + 2);
			int wlength = ::MultiByteToWideChar(CP, 0, buf, length, wcbuf.buf, (int)wcbuf.size - 1);
			wcbuf.buf[wlength] = '\0';
			cbuf.Alloc(::WideCharToMultiByte(CP_ACP, 0, wcbuf.buf, wlength, NULL, 0, NULL, NULL) + 1);
			auto clength = ::WideCharToMultiByte(CP_ACP, 0, wcbuf.buf, wlength, cbuf.buf, (int)cbuf.size, NULL, NULL);
			cbuf.buf[clength] = '\0';
		}
	};
	typedef UTF78Reader_template<CP_UTF7> UTF7Reader;
	typedef UTF78Reader_template<CP_UTF8> UTF8Reader;
	struct UTF16LEReader : public base_Reader < wchar_t, '\r', '\n' > {
		UTF16LEReader(OutputFunction f) : base_Reader<wchar_t, '\r', '\n'>([] (wchar_t) {return false; }, f) {}
		void ConvertCode(wchar_t *buf, int length, ablib::SmallBuffer<char> &cbuf, ablib::SmallBuffer<wchar_t> &wcbuf);
	};
	struct UTF16BEReader : public base_Reader < wchar_t, '\r' << 8, '\n' << 8 > {
		UTF16BEReader(OutputFunction f) : base_Reader<wchar_t, '\r' << 8, '\n' << 8>([] (wchar_t) {return false; }, f) {}
		void ConvertCode(wchar_t *buf, int length, ablib::SmallBuffer<char> &cbuf, ablib::SmallBuffer<wchar_t> &wcbuf);
	};
};

#endif //__COMPILE_H__

