#include "stdafx.h"
#include <stdio.h>
#include <set>
#include <ablib/TextFile.h>
#include "resource.h"
#include "func.h"
#include "edit.h"

extern HINSTANCE g_dllint;

Edit::Edit() : BaseModalDlg(g_dllint),m_pos(-1,-1){
	AddSubClass(&m_edit, IDC_EDIT1);
}

const TCHAR *Edit::Create(HWND hwnd,const TCHAR *listfile,const TCHAR *title,const TCHAR *str){
    DEBUGSTRING("set m_list");
	m_list = listfile;
    DEBUGSTRING("set m_title");
	m_title = title;
    DEBUGSTRING("set m_defstr");
	m_defstr = (str != NULL ? str : _T(""));
    DEBUGSTRING("ResetResultStr");
	m_edit.ResetResultStr();
    DEBUGSTRING("Wnd");
	ablib::window::Wnd w(hwnd);
    DEBUGSTRING("Create");
	BaseModalDlg::Create(&w,IDD_DLG_EDIT);
	return m_edit.GetResult();
}


bool Edit::OnInitDialog(ablib::window::Dialog *wnd){
	ablib::TextFile tf;
	std::set<ablib::string> list;
	if(m_list == _T(""))return true;
	if(tf.Open(m_list,ablib::TextFile::read)){
		TCHAR buf[4096];
		while(tf.ReadLine(buf,4095)){
			int len = ::lstrlen(buf);
			if(len > 0 && buf[len - 1] == '\n')buf[len - 1] = '\0';
			if(*buf)list.insert(buf);
		}
		tf.Close();
	}else{
		ablib::string::size_type p = 0;
		while(m_list[0] == ',')++p;
		ablib::string::size_type q = p;
		while((p = m_list.find(_T(","),q)) != ablib::string::npos){
			list.insert(m_list.substr(q,p - q));
			q = p + 1;
		}
		if(m_list.length() > q)list.insert(m_list.substr(q));
	}
	ablib::window::List(wnd,IDC_EDIT_LIST).SendMsg(WM_SETREDRAW,TRUE,0);
	wnd->SetTitle(m_title);
	ablib::window::Rect rect = wnd->GetRect();
	ablib::window::Size size(rect.right - rect.left,rect.bottom - rect.top);
	if(m_pos.x >= 0 && m_pos.y >= 0)wnd->Move(m_pos,size);
	::ImmAssociateContext(wnd->GetHWND(),0);
	m_edit.SetList(list);
	ablib::window::Edit(&(*m_edit.GetWindow())).SetText(m_defstr);


/*
	ablib::window::Wnd *parent = wnd->GetParent();
	ablib::window::Rect parentrect = parent->GetRect();
	ablib::window::Rect rect = wnd->GetRect();
	wnd->Move(
		ablib::window::Point(
			parentrect.left + (parentrect.right - parentrect.left + rect.right - rect.left) / 2,
			parentrect.top + (parentrect.bottom - parentrect.top + rect.bottom - rect.top) / 2
		),
		ablib::window::Size(rect.right - rect.left,rect.bottom - rect.top));
*/
	return true;
}

bool Edit::EditDlg::OnChar(ablib::window::Dialog *wnd,TCHAR ch, intptr_t repeat){
	if(::GetKeyState(VK_CONTROL) < 0)return CtrlKey(ch);
	ablib::window::List list(wnd->GetParent(),IDC_EDIT_LIST);
	if(ch == ' '){
		auto n = list.GetCurSel();
		if(::GetKeyState(VK_SHIFT) < 0){
			if(n == 0)n = list.GetCount();
			list.SetCurSel(n - 1);
		}else{
			if(list.GetCount() == n + 1)list.SetCurSel(0);
			else list.SetCurSel(n + 1);
		}
		return true;
	}
	return false;
}

bool Edit::EditDlg::OnKey(ablib::window::Dialog *wnd,bool isDown,UINT vk, intptr_t repeat){
	if(isDown){
		ablib::window::List list(wnd->GetParent(),IDC_EDIT_LIST);
		auto n = list.GetCurSel();
		switch(vk){
		case VK_DOWN:	++n;break;
		case VK_UP:		--n;break;
		default:		return false;
		}
		list.SetCurSel(n);
		return true;
	}else return false;
}


INT_PTR Edit::EditDlg::OnOtherMessage(ablib::window::Dialog *wnd,UINT msg,WPARAM wParam,LPARAM lParam){
	switch(msg){
	case WM_GETDLGCODE:
		switch((int)wParam){
		case VK_TAB:
		{
			ablib::window::List list(wnd->GetParent(),IDC_EDIT_LIST);
			list.Reset();
			ablib::string str = ablib::window::Edit(wnd->GetParent(),IDC_EDIT1).GetText();
			std::set<ablib::string>::iterator end = m_list.end();
			for(std::set<ablib::string>::iterator p = m_list.begin() ; p != end ; ++p){
				if(p->find(str) == 0)list.AddString(p->c_str());
			}
			str = GetCommonStr(str);
			SelectFromText(str);
			ablib::window::Edit(wnd->GetParent(),IDC_EDIT1).SetText(str);
			ablib::window::Edit(wnd->GetParent(),IDC_EDIT1).SendMsg(EM_SETSEL,str.length(),str.length());
			return DLGC_WANTTAB;
		}
		case VK_RETURN:
		{
			ablib::window::List list(wnd->GetParent(),IDC_EDIT_LIST);
			auto i = list.GetCurSel();
			if(list.IsSel(i))m_rv = list.GetText(i);
			else m_rv = ablib::window::Edit(wnd->GetParent(),IDC_EDIT1).GetText();
			ablib::window::Dialog(wnd->GetParent()).Destroy(TRUE);
			return TRUE;
		}
		case VK_ESCAPE:
			ablib::window::Dialog(wnd->GetParent()).Destroy(FALSE);
			return TRUE;
		default:
			return DefaultProc(msg,wParam,lParam);
		}
	default:
		return DefaultProc(msg,wParam,lParam);
	}
}


ablib::string Edit::EditDlg::GetCommonStr(const ablib::string &str){
	if(str == _T(""))return _T("");
	ablib::string rv;
	ablib::window::List list(GetWindow()->GetParent(),IDC_EDIT_LIST);
	auto n = list.GetCount();
	ablib::string s;
	for(int i = 0 ; i < n ; ++i){
		s = list.GetText(i);
		if(s.find(str) == 0){
			if(rv == _T(""))rv = s;
			else{
				int j;
				for(j = 0 ; rv[j] == s[j] && rv[j] != '\0' ; ++j);
				rv.assign(s,0,j);
			}
		}
	}
	return rv;
}

void Edit::EditDlg::SelectFromText(const ablib::string &text){
	ablib::window::List list(GetWindow()->GetParent(),IDC_EDIT_LIST);
	auto n = list.GetCount();
	auto start = list.GetCurSel();
	intptr_t direct,i;
	ablib::string s;
	if(start == -1){
		start = 0;
		direct = 1;
	}else{
		s = list.GetText(start);
		i = ::lstrcmpi(s.c_str(),text.c_str()); 
		if(i == 0)return;
		else direct = i < 0 ? 1 : -1;
	}
	for(i = start ; i < n && i >= 0 ; i += direct){
		s = list.GetText(i);
		if(::lstrcmpi(s.c_str(),text.c_str()) * direct >= 0)break;
	}
	if(direct == -1 && ::lstrcmpi(s.c_str(),text.c_str()) != 0)++i;
	
	list.SetCurSel(i);
	return;

}

bool Edit::EditDlg::CtrlKey(TCHAR c){
	ablib::window::Edit edit(GetWindow()->GetParent(),IDC_EDIT1);
	switch(c + 64){
	case 'A':
		edit.SetSel(0,edit.GetText().length() + 10);
		return true;
	case 'C':
		edit.Copy();
		return true;
	case 'V':
		edit.Paste();
		return true;
	case 'X':
		edit.Cut();
		return true;
	case 'Z':
		edit.Undo();
		return true;
	default:
		return false;
	}
}

bool Edit::OnCommand(ablib::window::Dialog *wnd,int id, intptr_t param){
	switch(id){
	case IDC_EDIT1:
		switch(param){
		case EN_CHANGE:
		{
			ablib::window::List list(wnd,IDC_EDIT_LIST);
			list.Reset();
			ablib::string str = ablib::window::Edit(wnd,IDC_EDIT1).GetText();
			std::set<ablib::string>::iterator end = m_edit.m_list.end();
			for(std::set<ablib::string>::iterator p = m_edit.m_list.begin() ; p != end ; ++p){
				if(p->find(str) == 0)list.AddString(p->c_str());
			}
			m_edit.SelectFromText(str);
//			ablib::window::Edit(wnd,IDC_EDIT1).SetText(str);
//			ablib::window::Edit(wnd,IDC_EDIT1).SendMsg(EM_SETSEL,str.length(),str.length());
			return true;
		}
		default:
			return false;
		}
	default:
		return false;
	}
}
