#include "stdafx.h"
#include <stdio.h>
#include <algorithm>
#include <vector>
#include <system/File.h>
#include <window/Window.h>
#include <ablib/IsKanji.h>
#include <ablib/SmallBuffer.h>
#include "func.h"
#include "file.h"
#include "ForString.h"

extern ablib::string tmp_string;

namespace{
	inline bool IsRealFile(const TCHAR *file){
		return 
			!(
			(file[0] == '.' && file[1] == '\0') ||
			(file[0] == '.' && file[1] == '.' && file[2] == '\0')
			);
	}
}

File::~File(void){
	for(UINT i = 0 ; i < m_fp.size() ; ++i){
        if(m_fp[i])::fclose(m_fp[i]);
	}
}

intptr_t File::OpenFile(const TCHAR *fname,const TCHAR *mode){
	FILE *fp;
	if(::lstrcmp(fname,_T("")) == 0){
		::SetmacrodllLastError(_T("t@CłD"));
		return 0;
	}
	fp = ::_tfopen(fname,mode);
	if(fp == NULL){
		::SetmacrodllLastError(errno);
		return 0;
	}
	for(UINT i = 0 ; i < m_fp.size() ; ++i){
		if(m_fp[i] == NULL){
			m_fp[i] = fp;
			return i + 1;
		}
	}
	m_fp.push_back(fp);
	return m_fp.size();
}

const TCHAR *File::ReadFileLine(intptr_t fp){
	TCHAR str[4096];
	if(fp <= 0 || fp > static_cast<int>(m_fp.size()) || m_fp[fp - 1] == NULL){
		::SetmacrodllLastError("ȃnhłD");
		return _T("");
	}
	if(::_fgetts(str,4095,m_fp[fp - 1]) == NULL){
		::SetmacrodllLastError();
		return _T("");
	}else{
        tmp_string = str;
        return tmp_string.c_str();
    }
}

intptr_t File::Write(const TCHAR *text, intptr_t fp){
	if(fp <= 0 || fp > static_cast<int>(m_fp.size()) || m_fp[fp - 1] == NULL){
		::SetmacrodllLastError("ȃnhłD");
		return FALSE;
	}
	if(::_ftprintf(m_fp[fp - 1],_T("%s"),text) < 0){
		::SetmacrodllLastError();
		return FALSE;
	}else return TRUE;
}

intptr_t File::IsEOF(intptr_t fp){
	if(fp <= 0 || fp > static_cast<int>(m_fp.size()) || m_fp[fp - 1] == NULL){
		::SetmacrodllLastError(_T("ȃnhłD"));
		return -1;
	}else if(::feof(m_fp[fp - 1]) == 0)return 0;
	else return 1;
}

intptr_t File::CloseFile(intptr_t fp){
	if(fp <= 0 || fp > static_cast<int>(m_fp.size())){
		::SetmacrodllLastError("ȃnhłD");
		return FALSE;
	}
	if(m_fp[fp - 1]){
		if(::fclose(m_fp[fp - 1]) == 0){
			m_fp[fp - 1] = NULL;
			return TRUE;
		}else{
			::SetmacrodllLastError();
			return FALSE;
		}
	}else{
		::SetmacrodllLastError("ȃnhłD");
		return FALSE;
	}
}

const TCHAR *File::FindFirstFile(const TCHAR *pattern){
	m_findfile.Close();
	WIN32_FIND_DATA wfd;
	if(!m_findfile.Begin(pattern)){::SetmacrodllLastError(ablib::system::GetLastError());return _T("");}
	if(!m_findfile.Next(&wfd)){::SetmacrodllLastError(ablib::system::GetLastError());return _T("");}
	tmp_string = wfd.cFileName;
	return tmp_string.c_str();
}

const TCHAR *File::FindNext(){
	WIN32_FIND_DATA wfd;
	if(m_findfile.Next(&wfd)){
    	tmp_string = wfd.cFileName;
    	return tmp_string.c_str();
    }else return _T("");
}

intptr_t File::CompareTimeStamp(const TCHAR *fname1,const TCHAR *fname2){
	ablib::system::Time time1 = ablib::system::File::GetLastWriteTime(fname1);
	ablib::system::Time time2 = ablib::system::File::GetLastWriteTime(fname2);
	if(time1 > time2)return 1;
	else if(time1 == time2)return 0;
	else return -1;
}

const TCHAR *File::OpenFileDialog(HWND hwnd,const TCHAR *title,const TCHAR *filter,const TCHAR *defdir){
	int len = ::lstrlen(filter);
	ablib::string fil;
	fil.reserve(len);
	for(int i = 0 ; i < len ; ++i){
		if(filter[i] == '|')fil += '\0';
#ifndef UNICODE
		else if(ablib::IsKanji(filter[i])){fil.append(filter,i,2);++i;}
#endif
		else fil += filter[i];
	}
	fil += '\0';
	
	ablib::window::CommonDlg dlg(hwnd);
	if(!dlg.OpenFileDlg(tmp_string,fil.c_str(),title,defdir))return _T("");
	else return tmp_string.c_str();
}

const TCHAR *File::OpenDirDialog(HWND hwnd,const TCHAR *title,const TCHAR *defdir){
	ablib::window::CommonDlg dlg(hwnd);
	if(!dlg.SelectDir(tmp_string,title,defdir))return _T("");
	else return tmp_string.c_str();
}

intptr_t File::CheckSameFile(const TCHAR *filename1,const TCHAR *filename2){
	ablib::string f1,f2;
	if(::lstrcmp(filename1,_T("")) == 0 || ::lstrcmp(filename2,_T("")) == 0)return FALSE;
	f1 = TransRegularPath(filename1);
	f2 = TransRegularPath(filename2);
	f1.tolower();
	f2.tolower();
	return (f1 == f2);
}

const TCHAR *File::TransRegularPath(const TCHAR *fn){
	std::vector<ablib::string> sa,sa2;
	UINT i;
	int len = 0;
	String::split(sa,fn,_T("\\"));
	for(i = 0 ; i < sa.size() ; ++i){
        DEBUGSTRING("sa[i] = %s",sa[i].c_str());
		if(sa[i] == _T("."))continue;
		else if(sa[i] == _T("..")){if(!sa2.empty())sa2.pop_back();}
		else if(sa[i] == _T(""))continue;
		else sa2.push_back(sa[i]);
	}
	tmp_string = _T("");
	for(i = 0 ; i < sa2.size() ; ++i){
		if(i != 0)tmp_string += _T("\\");
		tmp_string += sa2[i];
	}
	return tmp_string.c_str();
}

struct FileLine{
	ablib::string str1,str2;
	static int opt;
	bool operator<(const FileLine &obj){return ::CompareString(LOCALE_USER_DEFAULT,opt,str1.c_str(),-1,obj.str1.c_str(),-1) == CSTR_LESS_THAN;}
	bool operator==(const FileLine &obj){return (str1 == obj.str1 && str2 == obj.str2);}
};
int FileLine::opt = 0;

intptr_t File::SortFile(const TCHAR *fname,const TCHAR *fname2, intptr_t casesense, intptr_t width){
	FileLine::opt = 0;
	if(!casesense)FileLine::opt |= NORM_IGNORECASE;
	if(!width)FileLine::opt |= NORM_IGNOREWIDTH;
	if(!fname2)fname2 = _T("");
	std::vector<FileLine> fl;
	TCHAR str[4096];
	FILE *fp = ::_tfopen(fname,_T("r"));
	if(!fp){::SetmacrodllLastError();return FALSE;}
	FILE *fp2 = ::_tfopen(fname2,_T("r"));
	FileLine f;
	while(::_fgetts(str,4096,fp)){
		f.str1 = str;
		if(fp2){
			::_fgetts(str,4096,fp2);
			f.str2 = str;
		}
		fl.push_back(f);
	}
	::fclose(fp);
	if(fp2)::fclose(fp2);
	std::sort(fl.begin(),fl.end());
	fl.erase(std::unique(fl.begin(),fl.end()),fl.end());
	fp = ::_tfopen(fname,_T("w"));
	if(!fp){::SetmacrodllLastError();return FALSE;}
	if(fp2)fp2 = ::_tfopen(fname2,_T("w"));
	for(std::vector<FileLine>::iterator i = fl.begin() ; i != fl.end() ; ++i){
		::_ftprintf(fp,_T("%s"),i->str1.c_str());
		if(fp2)::_ftprintf(fp2,_T("%s"),i->str2.c_str());
	}
	::fclose(fp);
	if(fp2)::fclose(fp2);
	return TRUE;
}

inline bool File::ExistsFile(const TCHAR *filename){
	return (::GetFileAttributes(filename) != static_cast<DWORD>(-1));
}

const TCHAR *File::Which(const TCHAR *cmd, intptr_t n){
	if(::IsBadStringPtr(cmd,1) != FALSE)return _T("");
	std::vector<ablib::string> envpath;
	ablib::string path;
	int bufsize = ::GetEnvironmentVariable(_T("PATH"),NULL,0) + 1;
	TCHAR *env = new TCHAR[bufsize + 1];
	::GetEnvironmentVariable(_T("PATH"),env,bufsize);
	String::split(envpath,env,_T(";"));
	delete[] env;
	UINT i;
	int found = 0;
	for(i = 0 ; i < envpath.size() ; ++i){
		if(envpath[i] == _T(""))continue;
		if(envpath[i][envpath[i].length()-1] != '\\')envpath[i] += _T("\\");
		path = envpath[i];
		path += cmd;
		path += _T(".exe");
		if(::GetFileAttributes(path.c_str()) != -1){
			if(found == n){
				tmp_string = path;
				return tmp_string.c_str();
			}else ++found;
		}
	}
	tmp_string = _T("");
	return tmp_string.c_str();
}

intptr_t File::DeleteFiles(const TCHAR *file){
	if(::lstrcmp(file,_T("")) == 0)return TRUE;
	WIN32_FIND_DATA wfd;
	HANDLE hFind;
	DWORD fatt = ::GetFileAttributes(file);
	if(fatt == static_cast<DWORD>(-1))return TRUE;
	if(!(fatt & FILE_ATTRIBUTE_DIRECTORY)){
        BOOL b = ::DeleteFile(file);
        if(!b)SetmacrodllLastError();
        return b;
    }
	ablib::string pattern = file;
	ablib::string dir = file;
	if(dir[dir.length() - 1] != '\\')dir += _T("\\");
	ablib::string d = file;
	pattern += _T("*.*");
	hFind = ::FindFirstFile(pattern.c_str(),&wfd);
	do{
		if(::lstrcmp(wfd.cFileName,_T(".")) == 0 || ::lstrcmp(wfd.cFileName,_T("..")) == 0)continue;
		d = dir;
		d += wfd.cFileName;
		if(wfd.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY){
			d += _T("\\");
			File::DeleteFiles(d.c_str());
		}else ::DeleteFile(d.c_str());
	}while(::FindNextFile(hFind,&wfd));

	::FindClose(hFind);
	d = dir;
	d.erase(d.length() - 1);
	::RemoveDirectory(d.c_str());
	return TRUE;
}

intptr_t File::CreateDir(const TCHAR *dir){
	const TCHAR *trp = TransRegularPath(dir);
	TCHAR *q = new TCHAR[::lstrlen(trp) + 3];
	::lstrcpy(q,trp);
	if(q[::lstrlen(q) - 1] != '\\')::lstrcat(q,_T("\\"));
#ifdef UNICODE
	for(TCHAR *p = q ; *p ; ++p){
#else
	for(TCHAR *p = q ; *p ; p += (IsKanji(*p) ? 2 : 1)){
#endif
		if(*p == '\\'){
			*p = '\0';
			if(!ExistsFile(q) && !::CreateDirectory(q,NULL)){
				delete[] q;
				return FALSE;
			}
			*p = '\\';
		}
	}
	delete[] q;
	return TRUE;
}

const TCHAR *File::GetDrives(){
	TCHAR rv[64];
	DWORD drives = ::GetLogicalDrives();
	TCHAR *p = rv;
	for(int pos = 0 ; drives ; drives >>= 1 , ++pos){
		if(drives & 1)*(p++) = 'A' + pos;
	}
	*p = '\0';
	tmp_string = rv;
	return tmp_string.c_str();
}

const TCHAR *File::GetLongPathName(const TCHAR *sfn){
	DWORD size = ::GetLongPathName(sfn,NULL,0);
	ablib::SmallBuffer<TCHAR> buf;
	buf.Alloc(size + 1);
	DWORD res = ::GetLongPathName(sfn,buf.buf,size + 1);
	if(res != 0)tmp_string = buf.buf;
	else tmp_string = _T("");
	return tmp_string.c_str();
}

const TCHAR *File::GetShortPathName(const TCHAR *lfn) {
	ablib::SmallBuffer<TCHAR> sb;
	sb.Alloc(::lstrlen(lfn) + 1);
	DWORD res = ::GetShortPathName(lfn, sb.buf, (DWORD)sb.size + 1);
	if(res != 0)tmp_string = sb.buf;
	else tmp_string = _T("");
	return tmp_string.c_str();
}

const TCHAR *File::GetAssociation(const TCHAR *ext){
	ablib::string tmpfile = GetTempDir() + _T("\\abenori_fortex") + ext;
	TCHAR path[MAX_PATH + 1] = {0};
	FILE *fp = ::_tfopen(tmpfile.c_str(),_T("w"));
	if(fp){
		::fclose(fp);
		if(::GetFileAttributes(tmpfile.c_str()) != -1){
			if(reinterpret_cast<intptr_t>(::FindExecutable(tmpfile.c_str(),NULL,path)) > 32){
				::DeleteFile(tmpfile.c_str());
				tmp_string = path;
				return tmp_string.c_str();
			}
		}
		::DeleteFile(tmpfile.c_str());
	}
	DWORD size = MAX_PATH;
	HRESULT const hr = ::AssocQueryString(ASSOCF_NOTRUNCATE, ASSOCSTR_EXECUTABLE,ext,"open",path,&size);
	if(SUCCEEDED(hr) && size > 0){
        tmp_string = path;
		return tmp_string.c_str();
	}else{
		::SetmacrodllLastError();
		return _T("");
	}
}

ablib::string File::GetTempDir() {
	TCHAR *buf = NULL;
	DWORD size = ::GetTempPath(0, buf);
	buf = new TCHAR[size + 2];
	::GetTempPath(size + 1, buf);
	tmp_string = buf;
	delete[] buf;
	return tmp_string.c_str();
}
