#include "stdafx.h"
#include <system/FindFile.h>
#include "func.h"
#include "fileopen.h"
#include "resource.h"

extern HINSTANCE g_dllint;

FileOpen::FileOpen(void) : BaseModalDlg(g_dllint){
	AddSubClass(&m_edit,IDC_EDIT1);
}

const TCHAR *FileOpen::Create(HWND hwnd,TCHAR *defname,TCHAR *title,TCHAR *dir){
	m_def = defname;m_title = title;
	m_edit.SetDir(dir);m_edit.ClearResult();
	ablib::window::Wnd w(hwnd);
	BaseModalDlg::Create(&w,IDD_DLG_EDIT);
	return m_edit.GetResult();
}


bool FileOpen::OnInitDialog(ablib::window::Dialog *wnd){
	wnd->SetTitle(m_title);
	ablib::window::Edit(wnd,IDC_EDIT1).SetText(m_def);
	ablib::window::Edit(wnd,IDC_EDIT1).SetSel(m_def.length(),m_def.length());
	return true;
}

bool FileOpen::EditProc::OnChar(ablib::window::Dialog *wnd,TCHAR ch, intptr_t repeat){
	if(::GetKeyState(VK_CONTROL) < 0)return CtrlKey(ch);
	else return false;
}

bool FileOpen::EditProc::OnKey(ablib::window::Dialog *wnd,bool isDown,UINT vk,intptr_t repeat){
	if(isDown){
		switch(vk){
		case VK_DOWN:
			ablib::window::List(wnd->GetParent(),IDC_EDIT_LIST).SetCurSel(
				ablib::window::List(wnd->GetParent(),IDC_EDIT_LIST).GetCurSel() + 1
				);
			return true;
		case VK_UP:
			ablib::window::List(wnd->GetParent(),IDC_EDIT_LIST).SetCurSel(
				ablib::window::List(wnd->GetParent(),IDC_EDIT_LIST).GetCurSel() - 1
				);
			return true;
		default:
			return false;
		}
	}else return false;
}

INT_PTR FileOpen::EditProc::OnOtherMessage(ablib::window::Dialog *wnd,UINT msg,WPARAM wParam,LPARAM lParam){
	switch(msg){
	case WM_GETDLGCODE:
		switch((int)wParam){
		case VK_TAB:
			Hokan();
			return DLGC_WANTTAB;
		case VK_RETURN:
			m_rv = ablib::window::Edit(wnd->GetParent(),IDC_EDIT1).GetText();
			ablib::window::Dialog(wnd->GetParent()).Destroy(TRUE);
			return TRUE;
		case VK_ESCAPE:
			ablib::window::Dialog(wnd->GetParent()).Destroy(FALSE);
			return TRUE;
		default:
			return DefaultProc(msg,wParam,lParam);
		}
	default:
		return DefaultProc(msg,wParam,lParam);
	}
}

void FileOpen::EditProc::Hokan(){
	ablib::window::List list(GetWindow()->GetParent(),IDC_EDIT_LIST);
	list.Reset();
	ablib::window::Edit edit(GetWindow()->GetParent(),IDC_EDIT1);
	ablib::string curedit = edit.GetText();
	ablib::string pt = m_dir + curedit + _T("*.*");
	
	ablib::system::FindFile ff;
	WIN32_FIND_DATA wfd;
	if(!ff.Begin(pt))return;
	
	while(ff.Next(&wfd)){
		ablib::string s = wfd.cFileName;
		if(wfd.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)s += _T("\\");
		list.AddString(s);
	}
	ff.Close();
	ablib::string s = GetCommonStr();
	if(s != _T("")){
		curedit.erase(curedit.rfind(_T("\\")) + 1);
		curedit += s;
	}
	edit.SetText(curedit);
	edit.SetSel(curedit.length(),curedit.length());
	return;
}

ablib::string FileOpen::EditProc::GetCommonStr(){
	ablib::string rv;
	ablib::window::List list(GetWindow()->GetParent(),IDC_EDIT_LIST);
	auto n = list.GetCount();
	ablib::string s;
	rv = list.GetText(0);
	for(int i = 1 ; i < n ; ++i){
		s = list.GetText(i);
		int j;
		for(j = 0 ; ::tolower(rv[j]) == ::tolower(s[j]) && rv[j] != '\0' ; ++j);
		rv.assign(s,0,j);
	}
	return rv;
}

bool FileOpen::EditProc::CtrlKey(TCHAR c){
	ablib::window::Edit edit(GetWindow()->GetParent(),IDC_EDIT1);
	switch(c + 96){
	case 'a':
		edit.SetSel(0,edit.GetText().length() + 1);
		return true;
	case 'z':
		edit.Undo();
		return true;
	case 'x':
		edit.Cut();
		return true;
	case 'c':
		edit.Copy();
		return true;
	case 'v':
		edit.Paste();
		return true;
	default:
		return false;
	}
}

