#include "stdafx.h"
#include <ablib/lexical_cast.h>
#include <ablib/IsKanji.h>
#include "ispell.h"

intptr_t ISpell::Init(const TCHAR *cmd,const TCHAR *opt,const TCHAR *curdir){
	if(!m_process.HasExited()){
		SetmacrodllLastError(_T("ispell͊ɋNĂD"));
		return FALSE;
	}

	ablib::system::Process::ProcessStartInfo si;
	si.FileName = _T("");
	si.Arguments = ablib::string(_T("\"")) + cmd + _T("\" ") + opt + _T(" -a");
	si.WorkingDirectory = curdir;
	si.RedirectStandardOutput = si.RedirectStandardError = si.RedirectStandardInput = true;
	si.CreateNoWindow = true;
	si.ShowState = ablib::system::Process::ProcessStartInfo::hide;
	m_process.StartInfo(si);

	//ϐݒ
	TCHAR *envval;
	ENVS defenv;
	//ϐ
	for (auto &i : m_env){
		//̊ϐ擾
		int bufsize = ::GetEnvironmentVariable(i.first.c_str(),NULL,0) + 1;
		envval = new TCHAR[bufsize + 1];
		::GetEnvironmentVariable(i.first.c_str(),envval,bufsize);
		defenv[i.first] = envval;
		delete[] envval;
		//ϐݒ
		bufsize = ::ExpandEnvironmentStrings(i.second.c_str(),NULL,0) + 1;
		envval = new TCHAR[bufsize + 1];
		::ExpandEnvironmentStrings(i.second.c_str(),envval,bufsize - 1);
		::SetEnvironmentVariable(i.first.c_str(),envval);
		delete[] envval;
	}
	if(!m_process.Start()){
		for (auto &i : defenv){	
			::SetEnvironmentVariable(i.first.c_str(),i.second.c_str());
		}
		SetmacrodllLastError(_T("ispell̋NɎs"));
		return FALSE;
	}
	//ϐ߂
	for (auto &i : defenv){
		::SetEnvironmentVariable(i.first.c_str(),i.second.c_str());
	}

	TCHAR buf[4096];
	ablib::string errmsg;
	DWORD readsize;
	while(true){
		readsize = m_process.Read(buf,4095);
		buf[readsize] = '\0';
		errmsg += buf;
		if(errmsg.find(_T("\r\n")) != ablib::string::npos)break;
	}
	SetmacrodllLastError(errmsg);
	::Sleep(100);
	return m_process.HasExited() ? FALSE : TRUE;
}

bool ISpell::GetInput(const ablib::string &in,ablib::string &rv){
	DWORD be = ::GetTickCount();
	TCHAR buf[4096];
	DEBUGSTRING(_T("macrodll::ISpell::GetInput u%svispellɑM"),in.c_str());
	m_process.Write(in.c_str(),(int)in.length());
	rv = _T("");
	while(true){
		DWORD readsize = m_process.Read(buf,4094);
		buf[readsize] = '\0';
		rv += buf;
		if(::GetTickCount() - be > 2000){
			SetmacrodllLastError(_T("ispell\"));
			DEBUGSTRING(_T("macrodll::ISpell::GetInput : ߂ĺu%sv"),rv.c_str());
			return false;
		}
		if(rv.find(_T("\r\n\r\n")) != ablib::string::npos || rv.find(_T("\r\n")) == 0){
			DEBUGSTRING(_T("macrodll::ISpell::GetInput : ߂ĺu%sv"),rv.c_str());
			return true;
		}
	}
}


inline bool ISpell::IsSkipChar(TCHAR c){
	return 
	(  c == '*' || c == '@' || c == '#' || c == '~' || c == '+'
	|| c == '-' || c == '!' || c == '%' || c == '`' || c == '^'
	|| c == '&'
	// ͉̂ƃXy`FbNɂЂȂȂ镶D
	|| c == '.' );
}

bool ISpell::CheckLine(const ablib::string &line){
	if(line == _T(""))return false;
	if(line[0] == '#'){
		// ́Fthis is abenori
		// óF# abenori 8
		m_checkstr.clear();
		ablib::string data;
		data.assign(line,2,ablib::string::npos);
		m_length = data.find(_T(" "));
		data.erase(0,m_length + 1);
		m_pos = ablib::lexical_cast<int>(data);
		return true;
	}else if(line[0] == '&' || line[0] == '?'){
		// &:
		// ́Fttest
		// óF& ttest 4 0: attest, test, t test, t-test

		// ?
		// input : "this is uniqly"
		// ? uniqly 0 8: UN+IQ+LY
		ablib::string data,replaces;
		data.assign(line,2,line.find(_T(":")));//data = uttest 4 0:v
		replaces.assign(line,line.find(_T(":")) + 2,ablib::string::npos);//replaces = attest, test, t test, t-test
		replaces += _T(", ");
		m_length = data.find(_T(" "));
		data.erase(0,m_length + 1);
		data.erase(0,data.find(_T(" ")) + 1);
		data.erase(data.find(_T(":")));

		m_pos = ablib::lexical_cast<int>(data.c_str());
		m_checkstr.clear();
		ablib::string::size_type r;
		while((r = replaces.find(_T(", "))) != ablib::string::npos){
			m_checkstr.push_back(replaces.substr(0,r));
			replaces.erase(0,r + 2);
		}
		return true;
	}else if(line[0] == '+'){
		// input : "is"
		// + I
		return false;//悢CD
	}else if(line[0] == '-'){
		return false;//悭킩ȂD
	}else return false;
}

intptr_t ISpell::CheckDown(const TCHAR *in){
	DEBUGSTRING(_T("macrodll::ISpell::CheckDown %s`FbN"),in);
	ablib::string target;
	intptr_t addpos = 0;
	const TCHAR *inend = in + ::lstrlen(in);
	target.reserve(210);
	ablib::string result;
	while(inend > in){
		while(IsSkipChar(*in)){++in;++addpos;}
		target.assign(in,0,Min(inend - in,(intptr_t)200));
		in += target.length();
		if(target == _T(""))continue;

#ifndef UNICODE
		if(ablib::IsKanji(target[target.length() - 1]) && !ablib::IsKanji2(target.c_str(),target.length() - 1))target += *in++;
#endif
		while(IsAlphabet(*in))target += *in++;
		target += '\n';

		if(!GetInput(target,result))return -2;

		if(result == _T("*\r\n")){addpos += target.length() - 1;continue;}
		ablib::string line;
		ablib::string::size_type r;
		do{
			r = result.find(_T("\r\n"));
			line.assign(result,0,r);
			result.erase(0,r + 2);
			if(CheckLine(line)){
				m_pos += addpos;
				return m_pos;
			}
		}while(r != ablib::string::npos);
		addpos += target.length() - 1;
	}
	return -1;
}

intptr_t ISpell::CheckUp(const TCHAR *in){
	DEBUGSTRING(_T("macrodll::ISpell::CheckUp %s`FbN"),in);
	ablib::string target;
	int len = ::lstrlen(in);
	int start = len;
	target.reserve(len + 10);
	while(start > 0){
		int end = start;
		start -= Min(start,200);
		target.assign(in,start,end);
		while(start > 0 && IsAlphabet(*(in + start - 1))){
			--start;
			target.insert(0,in + start,1);
		}
#ifndef UNICODE
		if(ablib::IsKanji2(in,start)){
			++start;
			target.erase(0,1);
		}
#endif
		int addpos = start;
		while(IsSkipChar(target[0])){target.erase(0,1);++addpos;}
		target += '\n';

		ablib::string result;
		if(!GetInput(target,result))return -2;
		if(result == _T("*\r\n"))continue;
		TCHAR buf[4096];
		::lstrcpy(buf,result.c_str());

		ablib::string line;
		ablib::string::size_type r;
		do{
			r = result.rfind(_T("\r\n"));
			line.assign(result,r == ablib::string::npos ? 0 : r + 2,ablib::string::npos);
			if(r != ablib::string::npos)result.erase(r);
			if(CheckLine(line)){
				m_pos += addpos;
				return m_pos;
			}
		}while(r != ablib::string::npos);
	}
	return -1;
}

intptr_t ISpell::AddDic(const TCHAR *word){
	ablib::string input;
	input = _T("*");
	input += word;
	input += _T("\n");
	return Command(input);
}

intptr_t ISpell::AcceptWord(const TCHAR *word){
	ablib::string input;
	input = _T("@");
	input += word;
	input += _T("\n");
	return Command(input);
}

intptr_t ISpell::Command(const ablib::string &cmd){
	m_process.Write(cmd.c_str(),(DWORD)cmd.length());
	::Sleep(20);
	TCHAR buf[4096];
	buf[m_process.Read(buf,4095)] = '\0';
	if(::lstrcmp(buf,_T("")) != 0){SetmacrodllLastError(buf);return FALSE;}
	else return TRUE;
}

intptr_t ISpell::UnInit(){
	if(m_process.HasExited())return FALSE;
	TCHAR buf[3];
	buf[0] = 26;//Ctrl + Z
	buf[1] = '\n';
	buf[2] = '\0';
	m_process.Write(buf,2);
	if(!m_process.WaitForExit(1000))m_process.Kill();
	return TRUE;
}


