#ifndef __ISPELL_H__
#define __ISPELL_H__


#include <vector>
#include <map>
#include <system/Process.h>
/**
ispell
*/

class ISpell
{
public:
	ISpell(){}
	~ISpell(){UnInit();}
	intptr_t Init(const TCHAR *cmd,const TCHAR *opt,const TCHAR *curdir);
	intptr_t UnInit();
	intptr_t CheckDown(const TCHAR *line);
	intptr_t CheckUp(const TCHAR *line);
	const TCHAR *GetCheckStr(intptr_t i){if(i < 0 || i >= GetCheckStrNum())return _T("");return m_checkstr[i].c_str();}
	intptr_t GetCheckPos() const{return m_pos;}
	intptr_t GetCheckLen() const{return m_length;}
	intptr_t GetCheckStrNum() const{return m_checkstr.size();}
	intptr_t AddDic(const TCHAR *word);
	intptr_t AcceptWord(const TCHAR *word);
//	const TCHAR *ErrMsg(){return m_errmsg.c_str();}
	intptr_t SetEnv(const TCHAR *name,const TCHAR *val){m_env[name] = val;return TRUE;}
	intptr_t ClearEnv(){m_env.clear();return TRUE;}


private:
	typedef std::map<ablib::string,ablib::string> ENVS;

	intptr_t Command(const ablib::string &cmd);
	bool GetInput(const ablib::string &in,ablib::string &rv);
	bool CheckLine(const ablib::string &line);
	bool IsAlphabet(TCHAR c){return ('A' <= c && c <= 'Z') || ('a' <= c && c <= 'z');}

	bool IsSkipChar(TCHAR c);

	std::vector<ablib::string> m_checkstr;
	ENVS m_env;
 
	intptr_t m_pos,m_length;//ԈĂ镶̈ʒuƒD
	ablib::system::Process m_process;
};

#endif //__ISPELL_H__

