#ifndef __LISTBOXWND_H__
#define __LISTBOXWND_H__

#include <vector>
#include <window/BaseWnd.h>

/*
샊Xg{bNXD
̊ǗvectorNXsD

ꂵDR[hꂵD
*/

class ListBoxWnd : public ablib::window::BaseWnd{
private:
	class Buffer{
	public:
		struct STRDATA{
			STRDATA() : show(false){};
			STRDATA(const ablib::string &str,const ablib::string &comment,bool show) :
			str(str),comment(comment),show(show){};
			bool operator==(const STRDATA &obj) const{return (str == obj.str);}
			bool operator< (const STRDATA &obj) const{return ::CompareString(LOCALE_USER_DEFAULT,opt,str.c_str(),-1,obj.str.c_str(),-1) == CSTR_LESS_THAN;}
			bool operator> (const STRDATA &obj) const{return ::CompareString(LOCALE_USER_DEFAULT,opt,str.c_str(),-1,obj.str.c_str(),-1) == CSTR_GREATER_THAN;}
			ablib::string str;
			ablib::string comment;
			bool show;
			static DWORD opt;
		};
	private:
		std::vector<STRDATA> m_buf;
		std::vector<intptr_t> m_showline;

	public:
		Buffer() : m_issel(false),m_selindex(0){};
		~Buffer(){};
		intptr_t GetLineCount() const{return m_buf.size();}
		intptr_t GetShowCount() const{return m_showline.size();}
		bool GetData(intptr_t line,STRDATA &data){if(line < 0 || line >= GetLineCount())return false;data = m_buf[line];return true;}
		bool GetStr(intptr_t line,ablib::string &str){if(line < 0 || line >= GetLineCount())return false;str = m_buf[line].str;return true;}
		bool GetComment(intptr_t line,ablib::string &str){if(line < 0 || line >= GetLineCount())return false;str = m_buf[line].comment;return true;}
		bool GetShowData(intptr_t line,STRDATA &data){if(line < 0 || line >= GetShowCount())return false;data = m_buf[m_showline[line]];return true;}
		bool GetShowStr(intptr_t line,ablib::string &str){if(line < 0 || line >= GetShowCount())return false;str = m_buf[m_showline[line]].str;return true;}
		bool GetShowComment(intptr_t line,ablib::string &str){if(line < 0 || line >= GetShowCount())return false;str = m_buf[m_showline[line]].comment;return true;}
		bool GetFixedComment(ablib::string &str){str = m_fixedcomment;return true;}
		bool InsertText(intptr_t line,const STRDATA &data);
		bool InsertText(intptr_t line,const ablib::string &str,const ablib::string &comment,bool show){InsertText(line,STRDATA(str,comment,show));}
		bool DeleteText(intptr_t line);
		void AddText(const STRDATA &data);
		void AddText(const ablib::string &str,const ablib::string &comment,bool show){AddText(STRDATA(str,comment,show));}
		void SetFixedComment(const ablib::string &str){m_fixedcomment = str;}
		void RemoveAll(){m_buf.clear();m_showline.clear();}
		void Sort();
		void Uniq();
		void ShowClear();
		bool SetShow(intptr_t line,bool show);

		typedef std::vector<STRDATA>::size_type size_type;
		intptr_t m_selindex;
		bool m_issel;
		ablib::string m_fixedcomment;
	}m_buf;
	
	typedef Buffer::size_type size_type;

public:
	ListBoxWnd();
	~ListBoxWnd(){delete m_parent;}
	ablib::window::Window *Create(HWND hwnd, intptr_t x, intptr_t y,HINSTANCE appint,bool comment = false,bool commentfix = false);
	void ShowClear(){m_buf.ShowClear();}
	void TextClear(){m_buf.RemoveAll();m_buf.m_selindex = 0;}
	void AddStr(const TCHAR *text,const TCHAR *comment = _T("")){m_buf.AddText(text,comment,true);}
	void AddStr(const ablib::string &text,const ablib::string &comment = _T("")){m_buf.AddText(text,comment,true);}
	void InsertText(intptr_t line,const TCHAR *text,const TCHAR *comment = _T("")){m_buf.InsertText(line,text,comment,true);}
	void SetFixedComment(const ablib::string &str){m_buf.SetFixedComment(str);}
	bool Update();
	bool SetShowStr(intptr_t line,bool show = true){return m_buf.SetShow(line,true);}
	void SetSize(intptr_t v, intptr_t h){m_vsize = v;m_hsize = h;}
	void SetPos(intptr_t x, intptr_t y){if(GetWindow())GetWindow()->Move(ablib::window::Point((int)x,(int)y),ablib::window::Size(0,0));}
	bool SetSelect(intptr_t n, intptr_t sel){if(n < 0 || n >= m_buf.GetLineCount())return false;else{m_buf.m_selindex = n;if(sel)m_buf.m_issel = true;else m_buf.m_issel = false;return true;}}
	void SetShow(intptr_t show){if(show)m_isshow = true;else m_isshow = false;m_comwnd.SetShow(m_isshow);}
	void Sort(){m_buf.Sort();}
	void Uniq(){m_buf.Uniq();}
	void SetCompareStringOption(DWORD opt){Buffer::STRDATA::opt = opt;}
	intptr_t SetFont(const TCHAR *fontname, intptr_t size);
	bool Up(intptr_t n, intptr_t sel);

	const TCHAR *GetShowText(intptr_t n){if(m_buf.GetShowStr(n,tmp_string))return tmp_string.c_str();else return NULL;}
	const TCHAR *GetListText(intptr_t n){if(m_buf.GetStr(n,tmp_string))return tmp_string.c_str();else return NULL;}
	void Destroy(){if(GetWindow())GetWindow()->Destroy();}
	intptr_t GetCount() const{return m_buf.GetShowCount();}
	intptr_t GetSelect() const{if(m_buf.m_issel)return m_buf.m_selindex;else return -1;}
	intptr_t GetTextCount() const{return m_buf.GetLineCount();}
	bool IsShow() const{return m_isshow;}
	bool IsExist() const{return GetWindow() != NULL;}
	HWND GetHWND() const{return GetWindow()->GetHWND();}
	intptr_t GetWindowHeight(){return m_vsize * TextHeight() + 2;}
	intptr_t GetCommentWindowHeight(){return TextHeight() + 1;}

private:
	intptr_t m_vsize,m_hsize;
	bool m_isshow;
	bool m_comment;
	ablib::window::FontData m_font;
	ablib::window::Window *m_parent;
	ablib::string tmp_string;

	bool OnCreate(ablib::window::Window *wnd);
	bool OnPaint(ablib::window::Window *wnd);
	bool OnPaint(){OnPaint(GetWindow());}
	bool OnVScroll(ablib::window::Window *wnd, intptr_t dy);
	bool OnLButtonDown(ablib::window::Window *wnd,ablib::window::Mouse *mos);
	bool OnDestroy(ablib::window::Window *wnd);

	void SetScroll(intptr_t pos);
	intptr_t TextHeight(){return m_font.height + 2;}
	ablib::string m_fontname;
	intptr_t m_fontsize;

	//Rg
	class CommentWnd : public ablib::window::BaseWnd{
	public:
		CommentWnd(Buffer *b);
		ablib::window::Window *Create(ablib::window::Wnd *p){return BaseWnd::Create(p);}
		void SetListWnd(ablib::window::Window *wnd){m_listwnd = wnd;}
		void SetShow(bool b){m_isshow = b;}
		void SetFont(const ablib::string &fontname, intptr_t fontsize);
		bool OnPaint(){return OnPaint(GetWindow());}

	private:
		bool OnPaint(ablib::window::Window *wnd);
		bool OnCreate(ablib::window::Window *wnd);
		Buffer *m_buf;
		ablib::window::Window *m_listwnd;
		ablib::window::FontData m_font;
		intptr_t TextHeight(){return m_font.height + 2;}
		bool m_isshow;
		bool m_commentfix;
		friend class ListBoxWnd;
		ablib::string m_fontname;
		intptr_t m_fontsize;
	}m_comwnd;
	NOCOPY(ListBoxWnd);
};

#endif//__LISTBOXWND_H__

