#ifndef __WINDOW_H__
#define __WINDOW_H__

#include <vector>
#include <hmjre_dll/RegEx.h>

/**
WindowH
*/

class Window
{
public:
	Window(){}
	~Window(){}
	static intptr_t ShowWindow(HWND hwnd, intptr_t show){return ::ShowWindow(hwnd,(int)show);}
	static intptr_t IsIconic(HWND hwnd){return ::IsIconic(hwnd);}
	static intptr_t IsZoomed(HWND hwnd){return ::IsZoomed(hwnd);}
	intptr_t GetCaretPosX(HWND hwnd,const TCHAR *wclass);
	intptr_t GetCaretPosY(HWND hwnd,const TCHAR *wclass);
	intptr_t GetFontWidth(HWND hwnd,const TCHAR *wclass);
	intptr_t GetFontHeight(HWND hwnd,const TCHAR *wclass);
	intptr_t ClientToScreenX(HWND hwnd,const TCHAR *wclass, intptr_t x, intptr_t y);
	intptr_t ClientToScreenY(HWND hwnd,const TCHAR *wclass, intptr_t x, intptr_t y);
	static const TCHAR *GetWindowText(HWND hwnd);
	static intptr_t SetActiveWindow(HWND hwnd);
	static HWND GetActiveWindow();
	static intptr_t GetWindowLeft(HWND hwnd);
	static intptr_t GetWindowRight(HWND hwnd);
	static intptr_t GetWindowTop(HWND hwnd);
	static intptr_t GetWindowBottom(HWND hwnd);
	static intptr_t MoveWindow(HWND hwnd, intptr_t x, intptr_t y, intptr_t width, intptr_t height){return ::MoveWindow(hwnd,(int)x,(int)y,(int)width,(int)height,TRUE);}
	static const TCHAR *GetClassName(HWND hwnd);
//	static const TCHAR *GetExecFileName(HWND hwnd);
	
	intptr_t EnumWindow(const TCHAR *wclass,HWND hwnd);
	HWND GetEnumWindows(intptr_t i){if(i < 0 || i >= static_cast<intptr_t>(m_windows.size()))return NULL;else return m_windows[i];}

private:
	static BOOL CALLBACK sEnumWindowsProc(HWND hwnd,LPARAM lParam);
	BOOL EnumWindowsProc(HWND hwnd);
	std::vector<HWND> m_windows;
	HmJre::RegEx m_enumwreg;
};

#endif //__WINDOW_H__

