#include "stdafx.h"
#include <stdio.h>
#include <ablib/IsKanji.h>
#include <system/Process.h>
#include <boost/bind.hpp>
#include "version.h"
#include "func.h"
#include "compile.h"

namespace{
	const TCHAR WindowClassName[] = _T("AbenoriCompileWindowClass");
	const TCHAR message[] = 
		_T("j ")
		VERSION_SHORTSTR
		_T(" Copyright (C) Abe Noriyuki")
//		_T(" (abenori@ms.u-tokyo.ac.jp)")
		;
	const TCHAR EventName[] = _T("Abenori_fortex_Compile_Event");

}


extern HINSTANCE g_dllint;

Compile::Compile() : m_width(0),m_height(0),m_edit(g_dllint),m_charcode(0),m_read(false),
BaseWnd(WindowClassName,WS_TILED | WS_SIZEBOX | WS_SYSMENU,g_dllint)
{
	ablib::window::edit::EditWnd::EditConfig c = m_edit.GetConfig();
	c.NormalColor.Return = c.NormalColor.eof = ablib::window::rgb(::GetSysColor(COLOR_WINDOW));
	m_edit.SetConfig(c);
	m_edit.readonlyswitch();
	m_edit.Set(this);
	m_event = ::CreateEvent(NULL,TRUE,FALSE,EventName);
}

Compile::~Compile(){
	if(GetWindow())Close();
	::CloseHandle(m_event);
}

int Compile::Set(const TCHAR *set,const TCHAR *val){
#define SET(s) if(::lstrcmp(_T( #s ) , set) == 0){m_set. ## s = val;return TRUE;}
	SET(log);
	SET(pos);
	SET(title);
#undef SET
	return FALSE;
}

int Compile::Open(HWND hwnd,int x,int y){
	if(GetWindow())return TRUE;
	m_openwindow = true;
	HANDLE eve = ::OpenEvent(EVENT_ALL_ACCESS,FALSE,EventName);
	::ResetEvent(eve);
	m_thread = boost::shared_ptr<boost::thread>(new boost::thread(boost::bind(&Compile::MsgLoop,this,hwnd,x,y)));
	::EnableWindow(hwnd,FALSE);
	::WaitForSingleObject(eve,INFINITE);
	::CloseHandle(eve);

	return TRUE;
}

int Compile::Close(){
	::EnableWindow(GetWindow()->GetParent()->GetHWND(),TRUE);
	{
		LOCK l(this);
		m_edit.RemoveAllText();
		m_openwindow = false;
	}

	m_thread->timed_join(boost::posix_time::milliseconds(1000));

	return TRUE;
}


void Compile::MsgLoop(HWND hwnd,int x,int y){
	HANDLE eve = ::OpenEvent(EVENT_ALL_ACCESS,FALSE,EventName);

	if(m_set.pos == _T("absolute")){
		if(x < 0 || y < 0){x = CW_USEDEFAULT;y = 0;}
	}else{
        POINT pt;
		pt.x = x;pt.y = y;
		::ClientToScreen(hwnd,&pt);
		x = pt.x;y = pt.y;
	}
	int height,width;
	if(m_width <= 0 || m_height <= 0){width = CW_USEDEFAULT;height = 0;}
	else{width = m_width;height = m_height;}

	ablib::window::Window p(hwnd);
	ablib::window::Window *me = Create(&p);
	if(!me){
		::SetEvent(eve);
		::CloseHandle(eve);
		return;
	}

	ablib::window::Rect rc = me->GetRect();
	ablib::window::Point pos;
	ablib::window::Size size;
	if(x != CW_USEDEFAULT){pos.x = x;pos.y = y;}
	else{pos.x = rc.left;pos.y = rc.top;}
	if(width != CW_USEDEFAULT){size.width = width;size.height = height;}
	else{size.width = rc.right - rc.left;size.height = rc.bottom - rc.top;}
	me->Move(pos,size);
	me->SetTitle(m_set.title);


	m_edit.ClearHilight();
	DEBUGSTRING(_T("Hilightݒ"));
	for(std::vector<Hilight>::size_type i = 0 ; i < m_hilight.size() ; ++i){
		m_edit.AddHilight(m_hilight[i].keyword,m_hilight[i].option,m_hilight[i].position,
			m_hilight[i].color,m_hilight[i].back);
	}
	DEBUGSTRING(_T("SetEvent"));
	::SetEvent(eve);
	::CloseHandle(eve);

	// ɂȂƎ~܂Ⴄcc
	me->ShowWindow(ablib::window::Window::sw_show);

	// bZ[W[v񂷁D
	// m_processĂƂ͓ǂݏoD
	char buf[4096];
	bool end = false;
	int bufidx = 0,i;
	CharBuf<char> ins;
	ins.Alloc(4096);
	ablib::string s;
	MSG msg;
	GetWindow()->SetTitle(m_set.title);

	do{
		if(m_read){
			bool read_end = false;
			do{
				ablib::system::Process::wait_msg waitmsg;
				{
					LOCK l(this);
					waitmsg = m_process.WaitForMsg(20);
					if(!m_openwindow)GetWindow()->Destroy();
				}
				switch(waitmsg){
				case ablib::system::Process::message:
					// bZ[W[v񂵁cc΂ȁH
					while(::PeekMessage(&msg,0,0,0,PM_REMOVE)){
						if(msg.message == WM_QUIT)end = true;
						::TranslateMessage(&msg);
						::DispatchMessage(&msg);
					}
					break;
				case ablib::system::Process::process_exit:
					read_end = true;
					m_read = false;
					break;
				default:
					break;
				}
				{
					LOCK l(this);
					if(m_process.IsExited()){
						read_end = true;
						m_read = false;
					}else m_read = true;
				}
				while(true){
					DWORD readsize;
					{
						LOCK l(this);
						readsize = m_process.Read(buf + bufidx,4093);
					}
					if(!readsize)break;
					readsize += bufidx;
					buf[readsize] = '\0';
					//ȉsR[hDsakura editorQlɂĂ܂iƂwǃRsyłDjD
					//\r\n,\r\nɕϊD
					int k = 0;
					for(i = 0 ; i < static_cast<int>(readsize) - 1 ; ++i){
						if(buf[i] == '\r'){
							if(buf[i + 1] == '\n')++i;
							ins.buf[k++] = '\n';
#ifndef UNICODE
						}else if(ablib::IsKanji(buf[i])){
							ins.buf[k++] = buf[i++];ins.buf[k++] = buf[i];
#endif
						}else{
							ins.buf[k++] = buf[i];
							int a;
							a = 0;
						}
					}
					if(i == readsize - 1){
						if(buf[i] == '\r')i = readsize + 1;
#ifndef UNICODE
						else if(ablib::IsKanji(buf[i]))i = readsize + 1;
#endif
						else{ins.buf[k++] = buf[i];i = readsize;}
					}
					if(i == readsize)bufidx = 0;
					else{
						buf[0] = buf[readsize - 1];
						bufidx = 1;
					}
					ins.buf[k] = '\0';
					TransCode(ins,k,s);
					m_edit.gofileend();
					m_edit.insert(s);
					{
						LOCK l(this);
						if(m_logfp)::_ftprintf(m_logfp,_T("%s"),s.c_str());
					}
				}
			}while(!read_end);
			{
				LOCK l(this);
				if(m_process.IsExited()){
					HANDLE eve = ::OpenEvent(EVENT_ALL_ACCESS,FALSE,EventName);
					::SetEvent(eve);
					::CloseHandle(eve);
				}
			}
		}else{
			BOOL ret;
			while(ret = ::GetMessage(&msg,NULL,0,0)){
				if(ret == -1){
					end = true;
					break;
				}
				if(!m_openwindow)GetWindow()->Destroy();
				::TranslateMessage(&msg);
				::DispatchMessage(&msg);
				{
					LOCK l(this);
					if(m_read)break;
				}
			}
			if(ret == 0)end = true;
		}
	}while(!end);

	if(m_logfp)::_ftprintf(m_logfp,_T("\n\n"));

	return;

}

int Compile::Start(HWND hwnd, int x, int y, const TCHAR *command, const TCHAR *dir){
	bool opened = true;
	if(!GetWindow()){
		if(!Open(hwnd,x,y))return FALSE;
		opened = false;
	}else hwnd = GetWindow()->GetParent()->GetHWND();
	if(!StartProcess(hwnd,command,dir))return FALSE;
	if(!opened)Close();
	return TRUE;
}

int Compile::StartProcess(HWND parent,const TCHAR *command, const TCHAR *dir){
	HANDLE eve = ::OpenEvent(EVENT_ALL_ACCESS,FALSE,EventName);
	if(!eve)return FALSE;
	::ResetEvent(eve);

	ablib::system::Process::StartInfo si;
	si.FileName = _T("");
	si.Arg = command;
	si.WorkDir = dir;
	si.ReadStdOut = si.ReadStdErr = si.WriteStdIn = true;
	si.Window = false;si.ShowState = ablib::system::Process::StartInfo::hide;
	m_process.SetStartInfo(si);

	TCHAR *envval;
	std::vector<ENV> defenv;
	{
		LOCK l(this);
		if(m_set.log != _T(""))m_logfp = ::_tfopen(m_set.log.c_str(),_T("a"));
		else m_logfp = NULL;
	}

	m_edit.insert(message);
	m_edit.insert(_T("\nCOMMAND : "));
	m_edit.insert(command);
	m_edit.insert(_T("\n\n"));

	{
		LOCK l(this);
		if(m_logfp)::_ftprintf(m_logfp,_T("///////////////////////////////////////////////////\nCOMMAND : %s\n///////////////////////////////////////////////////\n"),command);
	}
	//ϐݒ
	//ϐ
	for(std::vector<ENV>::size_type i = 0 ; i < m_envs.size() ; ++i){
		//̊ϐ擾
		int bufsize = ::GetEnvironmentVariable(m_envs[i].name.c_str(),NULL,0) + 1;
		envval = new TCHAR[bufsize + 1];
		::GetEnvironmentVariable(m_envs[i].name.c_str(),envval,bufsize);
		defenv.push_back(ENV(m_envs[i].name.c_str(),envval));
		delete[] envval;
		//ϐݒ
		bufsize = ::ExpandEnvironmentStrings(m_envs[i].value.c_str(),NULL,0) + 1;
		envval = new TCHAR[bufsize + 1];
		::ExpandEnvironmentStrings(m_envs[i].value.c_str(),envval,bufsize - 1);
		::SetEnvironmentVariable(m_envs[i].name.c_str(),envval);
		delete[] envval;
	}

	{
		LOCK l(this);
		if(!m_process.Start()){
			SetLastError(ablib::system::GetLastError());
			for(std::vector<ENV>::size_type i =  0 ; i < defenv.size() ; ++i)::SetEnvironmentVariable(defenv[i].name.c_str(),defenv[i].value.c_str());
			::CloseHandle(eve);
			return FALSE;
		}
	}
	m_read = true;
	::WaitForSingleObject(eve,INFINITE);
	::CloseHandle(eve);

	if(m_logfp)::fclose(m_logfp);
	return TRUE;
}



bool Compile::OnCreate(ablib::window::Window *wnd){
	return (m_edit.Create(wnd) != NULL);
}

bool Compile::OnSize(ablib::window::Window *wnd,int sw,int width,int height){
	ablib::window::Rect rc = wnd->GetClientRect();
	ablib::window::Point pos(rc.left,rc.top);
	ablib::window::Size size(rc.right - rc.left,rc.bottom - rc.top);
	m_edit.GetWindow()->Move(pos,size);
	return true;
}

bool Compile::OnSetFocus(ablib::window::Window *wnd,ablib::window::Window *old){
	m_edit.GetWindow()->SetFocus();
	return true;
}

bool Compile::OnClose(ablib::window::Window *wnd){
	if(!m_process.IsExited()){
		if(wnd->MsgBox(_T("qvZXsBI܂H"),_T("G["),ablib::window::Window::mb_yesno) == ablib::window::Window::id_yes){
			// vZXICvZXĎ[`wnd->Destroy()𔭂̂ŁC
			// ł̓vZXÊ݁D
			m_process.Kill();
		}
		return true;
	}
	// ɂ邱Ƃ͎͂Ȃ͂D
	ASSERT(false);
	wnd->Destroy();
	return true;
}

bool Compile::OnDestroy(ablib::window::Window *wnd){
	if(!m_process.IsExited())m_process.Kill();
	return true;
}

bool Compile::Edit::OnChar(ablib::window::Window *wnd,TCHAR ch,int repeat){
	ablib::string::size_type n = m_keybuf.length();
	if(::GetKeyState(VK_CONTROL) < 0){
		ch += 96;
		switch(ch){
		case 'c':	copy();	return true;
		default:			return false;
		}
	}else{
		if(ch == 0x08){//BackSpace
			if(n != 0){
				m_keybuf.erase(n - 1);
				gofileend();
				backspace();
			}
		}else if(ch == '\r'){//Return
			m_keybuf += _T("\n");
			m_parent->m_process.Write(m_keybuf.c_str(),m_keybuf.length());
			if(m_parent->m_logfp)::_ftprintf(m_parent->m_logfp,_T("%s"),m_keybuf.c_str());
			insert(_T("\n"));
			gofileend();
			m_keybuf = _T("");
			return true;
		}else if(ch == 27 || ch == 9 || ch == 28 || ch == 29 || ch == 30 ||ch == 31)return false;//Esc,Tab,,,,
		else if(ch < 127){
			m_keybuf += ch;
			gofileend();
			insert(ch);
			return true;
		}
		return false;
	}
}

bool Compile::Edit::OnRButtonDown(ablib::window::Window *wnd,ablib::window::Mouse *mos,bool isDClick){
	ablib::window::Menu m(wnd);
	m.AddRootMenu(1,_T("SđI"));
	m.AddRootMenu(2,_T("Rs["));
	m.AddRootMenu(3,_T("SăRs["));
	switch(m.CreatePopupMenu(mos->GetPos())){
	case 1:
		selectall();
		return true;
	case 2:
		copy();
		return true;
	case 3:
	{
		ablib::string c;
		for(int i = 0 ; ; ++i){
			const TCHAR *p = GetText(i);
			if(!p)break;
			if(i != 0)c += _T("\n");
			c += p;
		}
		ablib::window::ClipBoard clip(wnd);
		if(!clip.IsOpen()){
			wnd->MsgBox(_T("Nbv{[hJ܂łD"),_T("j"));
			return true;
		}
		clip.SetText(c.c_str());
		return true;
	}
	default:
		return true;
	}
}
	

namespace{
	enum CodeSet{ ASCII, KANA, JIS};


	//JIS ZX 0208  Shift_JIS
	void jis2sjis(BYTE k,BYTE t,char *rv){
		if(k>=0x3f)	rv[0] = (char)(((k+1)>>1)+0xc0);
		else		rv[0] = (char)(((k+1)>>1)+0x80);
		if( k&1 )	rv[1] = (char)((t>>6) ? t+0x40 : t+0x3f);
		else		rv[1] = (char)(t+0x9e);
	}

	int tosjis(CodeSet cs,const char *input,int &offset,char *rv){
		BYTE c[2];
		switch(cs){
		case ASCII:
			rv[0] = input[offset];
			++offset;
			return 1;
		case JIS:
			c[0] = input[offset];c[1] = input[offset + 1];
			jis2sjis((c[0] & 0x7F) - 0x20,(c[1] & 0x7F) - 0x20,rv);
			offset += 2;
			return 2;
		case KANA:
			rv[0] = input[offset];
			++offset;
			return 1;
		default:
			return 0;
		}
	}
}

void Compile::TransCode(CharBuf<char> &str,int length,ablib::string &s){
	static CharBuf<wchar_t> wcharbuf;
	static CharBuf<char> charbuf;
	char c;//wchar_t w;
	switch(m_charcode){
	case 0:// VK
	case 1:// Shift_JIS
	default:
#ifdef UNICODE
		wcharbuf.Alloc(::MultiByteToWideChar(CP_ACP,0,str.buf,length,NULL,0) + 2);
		wcharbuf.buf[::MultiByteToWideChar(CP_ACP,0,str.buf,length,wcharbuf.buf,wcharbuf.size)] = '\0';
		s = wcharbuf.buf;
#else
		s = str.buf;
#endif
		return;
	case 2:// UnicodeiUTF-16Hj
	{
#ifdef UNICODE
		wcharbuf.Alloc(length);
		::CopyMemory(wcharbuf.buf,str.buf,length);
		wcharbuf.buf[(length + 1)/2] = '\0';
		s = wcharbuf.buf;
#else
		int wlength = (length + 1)/2;
		wcharbuf.Alloc(wlength);
		::CopyMemory(wcharbuf.buf,str.buf,length);
		charbuf.Alloc(::WideCharToMultiByte(CP_ACP,0,wcharbuf.buf,wlength,NULL,0,NULL,NULL) + 2);
		charbuf.buf[::WideCharToMultiByte(CP_ACP,0,wcharbuf.buf,wlength,charbuf.buf,charbuf.size,NULL,NULL)] = '\0';
		s = charbuf.buf;
#endif
		return;
	}
	case 7:// UnicodeiBig-Endianj
	{
		for(ablib::string::size_type i = 0 ; i < length ; i += 2){
			c = str.buf[i + 1];
			str.buf[i + 1] = str.buf[i];
			str.buf[i] = c;
		}
#ifdef UNICODE
		wcharbuf.Alloc(length);
		::CopyMemory(wcharbuf.buf,str.buf,length);
		wcharbuf.buf[(length + 1)/2] = '\0';
		s = wcharbuf.buf;
#else
		int wlength = (length + 1)/2;
		wcharbuf.Alloc(wlength);
		::CopyMemory(wcharbuf.buf,str.buf,length);
		str.Alloc(::WideCharToMultiByte(CP_ACP,0,wcharbuf.buf,wlength,NULL,0,NULL,NULL) + 2);
		str.buf[::WideCharToMultiByte(CP_ACP,0,wcharbuf.buf,wlength,str.buf,str.size,NULL,NULL)] = '\0';
		s = str.buf;
#endif
		return;
	}
	case 3:// EUC
	{
		CodeSet G[] = {ASCII,JIS,KANA,JIS};
		static const BYTE SS2 = 0x8E;
		static const BYTE SS3 = 0x8F;
		charbuf.Alloc(length + 10);
		int writesize = 0;
		for(int i = 0 ; i < length ;){
			charbuf.Alloc(writesize + 2);
			switch(str.buf[i]){
			case SS2:
				++i;
				writesize += tosjis(G[2],str.buf,i,charbuf.buf + writesize);
				break;
			case SS3:
				++i;
				writesize += tosjis(G[3],str.buf,i,charbuf.buf + writesize);
				break;
			default:
				if(str.buf[i] < 0){
					writesize += tosjis(G[1],str.buf,i,charbuf.buf + writesize);
				}else{
					writesize += tosjis(G[0],str.buf,i,charbuf.buf + writesize);
				}
				break;
			}
		}
		charbuf.buf[writesize] = '\0';
#ifdef UNICODE
		wcharbuf.Alloc(::MultiByteToWideChar(CP_ACP,0,charbuf.buf,writesize,NULL,0) + 2);
		wcharbuf.buf[::MultiByteToWideChar(CP_ACP,0,charbuf.buf,writesize,wcharbuf.buf,wcharbuf.size)] = '\0';
		s = wcharbuf.buf;
#else
		s = charbuf.buf;
#endif
		return;
	}
	case 4:// JIS
	{
		static const int ESC = 0x1B;
		CodeSet G0 = ASCII;
		charbuf.Alloc(length + 10);
		int writesize = 0;
		for(int i = 0 ; i < length ;){
			charbuf.Alloc(writesize + 2);
			switch(str.buf[i]){
			case ESC:
				++i;
				if(str.buf[i] == '('){
					if(str.buf[i + 1] == 'B' || str.buf[i + 1] == 'J')G0 = ASCII;
				}else if(str.buf[i] == '$'){
					if(str.buf[i + 1] == '@' || str.buf[i + 1] == 'B')G0 = JIS;
				}
				i += 2;
				break;
			case '\n':
				G0 = ASCII;
				charbuf.buf[writesize] = '\n';
				++writesize;++i;
				break;
			default:
				writesize += tosjis(G0,str.buf,i,charbuf.buf + writesize);
				break;
			}
		}
		charbuf.buf[writesize] = '\0';
#ifdef UNICODE
		wcharbuf.Alloc(::MultiByteToWideChar(CP_ACP,0,charbuf.buf,writesize,NULL,0) + 2);
		wcharbuf.buf[::MultiByteToWideChar(CP_ACP,0,charbuf.buf,writesize,wcharbuf.buf,wcharbuf.size)] = '\0';
		s = wcharbuf.buf;
#else
		s = charbuf.buf;
#endif
		return;
	}
	case 5:// UTF-7
	case 6:// UTF-8
	{
		int code = (m_charcode == 5 ? CP_UTF7 : CP_UTF8);
		wcharbuf.Alloc(::MultiByteToWideChar(code,0,str.buf,length,NULL,0) + 2);
		int wlength = ::MultiByteToWideChar(code,0,str.buf,length,wcharbuf.buf,wcharbuf.size - 1);
		wcharbuf.buf[wlength] = '\0';
#ifdef UNICODE
		s = wcharbuf.buf;
#else
		charbuf.Alloc(::WideCharToMultiByte(CP_ACP,0,wcharbuf.buf,wlength,NULL,0,NULL,NULL) + 2);
		charbuf.buf[::WideCharToMultiByte(CP_ACP,0,wcharbuf.buf,wlength,charbuf.buf,charbuf.size,NULL,NULL)] = '\0';
		s = charbuf.buf;
#endif
		return;
	}
	}

}

