#include "stdafx.h"
#include <ablib/textfile.h>
#include <ablib/bind.h>
#include <ablib/KRSearch.h>
#include <ablib/IsKanji.h>
#include <system/File.h>
#include "listbox.h"
#include "listboxwnd.h"


extern HINSTANCE g_dllint;

ListBox::ListBox(void){
	Set(_T(""),0);
}

ListBox::~ListBox(void){
	Destroy();
}

namespace{
	int CompStr(LCID Locale,DWORD dwCmpFlags,LPCTSTR lpString1,int cchCount1,LPCTSTR lpString2,int cchCount2){
		return ::CompareString(Locale,dwCmpFlags,lpString1,cchCount1,lpString2,cchCount2) - 2;
	}
}

#define SETVAL(s) if(::lstrcmpi(set,_T( #s )) == 0){if(val)m_listset. ## s = true;else m_listset. ## s = false;}

int ListBox::Set(TCHAR *set,int val){
	SETVAL(Show_only_match);
	SETVAL(CaseSense);
	SETVAL(Sort);
	SETVAL(Uniq);
	SETVAL(Width);
	SETVAL(comment_fix);

	int opt = 0;
	if(!m_listset.CaseSense) opt |= NORM_IGNORECASE;
	if(!m_listset.Width)opt |= NORM_IGNOREWIDTH;
	m_compare = ablib::bind(CompStr,LOCALE_USER_DEFAULT,opt,_1,_2,_3,_4);
	return TRUE;
}
#undef SETVAL

int ListBox::Create(HWND hwnd,int x,int y,const TCHAR *listfile,const TCHAR *comment){
	bool iscomment;
	TCHAR tmp[4096],tmp2[4096];
	const TCHAR *p,*pp,*q,*qq;
	int j;
	UINT i;
	DWORD fsize = ablib::system::File::GetSize(listfile);
	m_listwnd.TextClear();
	i = 0 ; j = 0;
	//t@C̃I[vɐ΂ꂩǂݏo
	ablib::TextFile tf;
	tf.Open(listfile,ablib::TextFile::read);
	if(tf.IsOpen()){
		ablib::TextFile tf2;
		if(!m_listset.comment_fix)tf2.Open(comment,ablib::TextFile::read);
		::lstrcpy(tmp2,_T(""));
		ablib::string t1,t2;
		while(tf.ReadLine(tmp,4096)){
			t1 = tmp;
			if(t1 != _T("") && t1[t1.length() - 1] == '\n')t1.erase(t1.length() - 1);
			if(tf2.IsOpen()){
				tf2.ReadLine(tmp2,4096);
				t2 = tmp2;
				if(t2 != _T("") && t2[t2.length() - 1] == '\n')t2.erase(t2.length() - 1);
				Escape(t2);
			}
			if(tmp[0] != '\0')m_listwnd.AddStr(t1,t2);
		}
		if(tf2.IsOpen())iscomment = true;else iscomment = false;
		tf.Close();
		tf2.Close();
	//łȂ","ŎaăXgɂ
	}else{
		if(m_listset.comment_fix || comment == NULL || ::lstrcmp(comment,_T("")) ==  0)iscomment = false;
		else iscomment = true;
		ablib::string t2;
		::lstrcpy(tmp,_T(""));
		::lstrcpy(tmp2,_T(""));
		p = listfile;q = comment;
		if(p[0] == ',')++p;
		if(iscomment && q[0] == ',')++q;
		while(pp = ablib::KRSearch::strstr(p,_T(","))){
			::lstrcpyn(tmp,p,pp - p + 1);
			p = pp + 1;
			if(iscomment)qq = ablib::KRSearch::strstr(q,_T(","));
			else qq = NULL;
			if(qq)::lstrcpyn(tmp2,q,qq - q + 1);
			else ::lstrcpy(tmp2,_T(""));
			if(qq)q = qq + 1;
			t2 = tmp2;Escape(t2);
			m_listwnd.AddStr(tmp,t2);
		}
		if(::lstrcmp(p,_T("")) != 0){
			if(q == NULL)t2 = _T("");
			else{t2 = q;Escape(t2);}
			m_listwnd.AddStr(p,t2);
		}
	}
	if(m_listset.Uniq)m_listset.Sort = true;
	if(m_listset.Sort)m_listwnd.Sort();
	if(m_listset.Uniq)m_listwnd.Uniq();
	if(comment && ::lstrcmp(comment,_T("")) != 0 && m_listset.comment_fix){
		iscomment = true;
		ablib::string c = comment;Escape(c);
		m_listwnd.SetFixedComment(c);
	}

	HWND me = m_listwnd.Create(hwnd,x,y,g_dllint,iscomment,m_listset.comment_fix);
//	ablib::window::Window *me = m_listwnd.Create(hwnd,x,y,g_dllint,iscomment,m_listset.comment_fix);
	::SetActiveWindow(hwnd);
	
	return (me != NULL);
}

// \\\ɁC\*\n*ɁDisR[hj
void ListBox::Escape(ablib::string &str){
	TCHAR tmp[3];tmp[2] = '\0';
	ablib::string rv;
	rv.reserve(str.length());
	ablib::string::size_type p = 0;
	for(ablib::string::size_type i = 0 ; i < str.length() ; ++i){
		if(str[i] == '\\'){
			rv.append(str,p,i - p);
			++i;
			if(str[i] == 'n' || str[i] == 'B' || str[i] == 'E'){
				p = i + 1;
				tmp[0] = '\n';tmp[1] = str[i];
				rv += tmp;
			}else if(str[i] == '\\'){
				p = i + 1;
				rv += _T("\\");
#ifndef UNICODE
			}else if(ablib::IsKanji(str[i])){
				p = i;
				++i;
#endif
			}else{
				p = i;
				rv += str[i];
			}
#ifndef UNICODE
		}else if(ablib::IsKanji(str[i])){
			++i;
#endif
		}
	}
	rv.append(str,p,ablib::string::npos);
	str = rv;
}



//textɍł߂ʒȗIʒuԂ
int ListBox::SelectFromText(TCHAR *text){
	int n,i,len,start,direct;
	int k;
	start = m_listwnd.GetSelect();
	n = m_listwnd.GetCount();
	len = ::lstrlen(text);
	//i荞
	if(m_listset.Show_only_match){
		m_listwnd.ShowClear();
		if(comparestr(text,_T("")) != 0){
			for(k = 0 ; k < m_listwnd.GetTextCount() ; ++k){
				if(firstmatchstr(text,m_listwnd.GetListText(k)) || ::lstrcmp(m_listwnd.GetListText(k),_T("")) == 0){
					m_listwnd.SetShowStr(k);
				}
			}
		}
		//SRȂ́cc
		if(m_listwnd.GetCount() == 0){
			//S\Ă܂
			for(k = 0 ; k < m_listwnd.GetTextCount() ; ++k)m_listwnd.SetShowStr(k);
			for(i = 0 ; i < m_listwnd.GetTextCount() ; ++i){
				if(comparestr(m_listwnd.GetShowText(i),text) >= 0)break;
			}
		}else{
			for(i = 0 ; i < m_listwnd.GetCount() ; ++i){
				if(comparestr(m_listwnd.GetShowText(i),text) >= 0)break;
			}
		}
	}else{
		if(start == -1){
			//IĂȂ
			start = 0;
			direct = 1;
		}else{
			i = comparestr(m_listwnd.GetShowText(start),text);
			if(i == 0)return start;
			else if(i < 0)direct = 1;
			else direct = -1;
		}
		//݂̑IʒuHĒׂĂB
		for(i = start ; i < n && i >= 0 ; i += direct){
			if(comparestr(m_listwnd.GetShowText(i),text) * direct >= 0)break;
		}
		if(direct == -1 && comparestr(m_listwnd.GetShowText(i),text) != 0)++i;
	}
	return i;

	//IׂꏊiɓĂB
//	m_listwnd.SetSelect(i);
//	m_listwnd.Update();

//	if(m_listset.CaseSense)return lstrcmpn(m_listwnd.GetShowText(i),text,::lstrlen(text));
//	else return lstrcmpin(m_listwnd.GetShowText(i),text,::lstrlen(text));
	
}

// ban܂镶ȂtrueD
bool ListBox::firstmatchstr(const TCHAR *a,const TCHAR *b){
#ifdef UNICODE
	return (m_compare(a,b,::lstrlen(a)) == 0);
#else
	int lena = ::lstrlen(a);
	int lenb = ::lstrlen(b);

	for(int i = lena / 2 ; i <= 2 * lena && i <= lenb ; ++i){
		if(m_compare(a,-1,b,i) == 0){
			return true;
		}
	}
	return false;
#endif
}

const TCHAR *ListBox::GetCommonStr(TCHAR *text){
	int j;
	static ablib::string rv;
	bool isfirst = true;
	rv = _T("");
	
	for(int i = 0 ; i < m_listwnd.GetCount() ; ++i){
		if(firstmatchstr(text,m_listwnd.GetShowText(i))){
			if(isfirst){
				rv = m_listwnd.GetShowText(i);
				isfirst = false;
			}else{
				for(j = 1 ; j <= rv.length() ; ++j){
					if(!firstmatchstr(rv.substr(0,j).c_str(),m_listwnd.GetShowText(i))){
						--j;
						break;
					}
				}
				rv.erase(j);
//				::lstrcpyn(rv,m_listwnd.GetShowText(i),j+1);
			}
		}
	}
	return rv.c_str();
}

