#ifndef __LISTBOX_H__
#define __LISTBOX_H__

#include <ablib/function.h>
#include "listboxwnd.h"

/**
⊮p̃Xg{bNXB
\ɂListBoxWndNXɂčLISTBOXgpB
*/

class ListBox
{
public:
	ListBox(void);
	~ListBox(void);
	int Create(HWND hwnd,int x,int y,const TCHAR *listfile,const TCHAR *comment = NULL);
	int Destroy(){m_listwnd.Destroy();return TRUE;}
	int Set(TCHAR *set,int val);
	const TCHAR *GetText(int n){return m_listwnd.GetShowText(n);}
	const TCHAR *GetSelText(){return GetText(GetSel());}
	int GetSel() const{return m_listwnd.GetSelect();}
	int SelectFromText(TCHAR *text);
	int SetSel(int n,int sel = TRUE){m_listwnd.SetSelect(n,sel);m_listwnd.Update();return TRUE;}
	int IsCreated(){if(m_listwnd.IsExist())return TRUE;else return FALSE;}
	int Up(int i,int sel = TRUE){if(m_listwnd.Up(i,sel))return TRUE;else return FALSE;}
	int GetCount(){return m_listwnd.GetCount();}
	int SetFont(TCHAR *fontname,int size){return m_listwnd.SetFont(fontname,size);}
	int SetSize(int v,int h){m_listwnd.SetSize(v,h);return TRUE;}
	int SetPos(int x,int y){m_listwnd.SetPos(x,y);return TRUE;}
	int SetShow(int show){m_listwnd.SetShow(show);return TRUE;}
	int Redraw(){return static_cast<int>(m_listwnd.Update());}
	int GetWindowHeight(){return m_listwnd.GetWindowHeight();}
	int GetCommentWindowHeight(){return m_listwnd.GetCommentWindowHeight();}
	const TCHAR *GetCommonStr(TCHAR *text);

private:
	struct LISTSET{
		LISTSET() : Show_only_match(false),CaseSense(false),Sort(false),Uniq(false),Width(false),comment_fix(false){}
		bool Show_only_match;
		bool CaseSense;
		bool Sort;
		bool Uniq;
		bool Width;
		bool comment_fix;
	}m_listset;

	ListBoxWnd m_listwnd;
	int FirstListText(TCHAR *text);
	ablib::function4<int,const TCHAR*,int,const TCHAR*,int> m_compare;
	int comparestr(const TCHAR *a,const TCHAR *b){return m_compare(a,-1,b,-1);}
	bool firstmatchstr(const TCHAR *a,const TCHAR *b);
	void Escape(ablib::string &str);

	NOCOPY(ListBox);

};
#endif //__LISTBOX_H__

