#ifndef __OLE_H__
#define __OLE_H__

#include <vector>

class OLE{
public:
	OLE();
	~OLE();

	int Initialize(const TCHAR *obj);
	int Connect(const TCHAR *obj);

	int SetPropertyInt(int handle,const TCHAR *prop,int val);
	int SetPropertyStr(int handle,const TCHAR *prop,const TCHAR *val);
	HRESULT Invoke_Sub(int handle, const TCHAR *func, int argc, VARIANTARG *argv){
		HRESULT hr = Invoke(handle,func,argc,argv,&m_result,DISPATCH_METHOD);
		if(m_result.vt == VT_DISPATCH && m_result.pdispVal){
			m_result.pdispVal->AddRef();
			m_disps.push_back(m_result.pdispVal);
		}
		return hr;
	}
	HRESULT Invoke(int handle, const TCHAR *func, int argc, VARIANTARG *argv, VARIANT *result, USHORT invoke_type);
	int GetLastResultInt();
	const TCHAR *GetLastResultStr();
	int GetLastResultDisp();
	int GetLastResultBool();
	void Clear();

	static OLECHAR *GetOleChar(const TCHAR *str);
	static ablib::string BSTR2String(BSTR bstr);
	HRESULT GetProperty(int handle,const TCHAR *prop,VARIANT *var,int argc,VARIANTARG *argv);

	static void double2time(double v, int *y, int *m, int *d, int *hh, int *mm, int *ss);
	static ablib::string Variant2Str(VARIANT &var);

private:
	std::vector<IDispatch*> m_disps;
	HRESULT SetProperty(IDispatch *disp,const char *prop,VARIANT *var);

	int Bind(const TCHAR *obj);
	ablib::string GetErrMsg(EXCEPINFO *ei);

	VARIANT m_result;

	static void jd2civil(long day,int *yy, int *mm, int *dd);
	static void d2time(double v, int *hh, int *mm, int *ss);
};

#endif //__OLE_H__

