#define UNICODE
#define _UNICODE

#include <windows.h>
#include <tchar.h>
#include <winnls.h>
#include <stdio.h>

const TCHAR *g_nameprefix = _T("\\\\.\\pipe\\abmcpipe_");

/*
pipe (start|stop|send) name 
*/

int MyCompareString(const TCHAR *str1,int len1,const TCHAR *str2,int len2){
  if(len1 != len2)return 1;
  for(int i = 0 ; i < len1 ; ++i){
    if(str1[i] != str2[i])return 1;
  }
  return 0;
}

const TCHAR *NextToken(const TCHAR *p){
  BOOL dq = FALSE;
  while(*p){
    if(*p == '"')dq = !dq;
    else if(*p == ' ' && !dq)return p;
//    p += (IsDBCSLeadByte(*p) != FALSE) ? 2 : 1;
    ++p;
  }
  return p;
}

int main(int argc,char *argv[]){
  int rv = 0;
  const TCHAR *act,*name,*str;
  int actlen,namelen;
  act = NextToken(GetCommandLine());
  while(*(++act) == ' ');
  name = NextToken(act);
  actlen = name - act;
  if(actlen > 0 && *act == L'"' && *(name + actlen - 1) == L'"'){
    ++act;actlen = actlen - 2;
  }
  while(*(++name) == L' ');
  str = NextToken(name);
  namelen = str - name;
  if(namelen > 0 && *name == L'"' && (*name + namelen - 1) == L'"'){
    ++name;namelen = namelen - 2;
  }
  while(*(++str) == L' ');
  int strlen = lstrlen(str);
  if(*str == L'"' && strlen > 0 && str[strlen - 1] == L'"'){
    ++str; strlen = strlen - 2;
  }
  HANDLE heap = HeapCreate(0,0,0);
  TCHAR *totalname = (TCHAR*)HeapAlloc(heap,HEAP_ZERO_MEMORY,sizeof(TCHAR)*(lstrlen(g_nameprefix) + namelen + 1));
  lstrcpy(totalname,g_nameprefix);
  lstrcpyn(totalname + lstrlen(g_nameprefix),name,namelen + 1);
  HANDLE mutex,pipe,hstdout;
  hstdout = GetStdHandle(STD_OUTPUT_HANDLE);
  if(MyCompareString(act,actlen,_T("start"),5) == 0){
    mutex = CreateMutex(NULL,TRUE,totalname + lstrlen(_T("\\\\.\\pipe\\")));
    if(GetLastError() != ERROR_ALREADY_EXISTS){
      pipe = CreateNamedPipe(
        totalname,
        PIPE_ACCESS_DUPLEX,PIPE_TYPE_BYTE | PIPE_READMODE_BYTE | PIPE_WAIT,
        PIPE_UNLIMITED_INSTANCES,1024,1024 /*܂Ӗ͂Ȃ */,
        0,NULL);
      if(pipe != INVALID_HANDLE_VALUE){
        BOOL end = FALSE;
        while(1){
          if(ConnectNamedPipe(pipe,NULL)){
            BYTE buf[1024];
            while(1){
              DWORD rsize;
              if(!ReadFile(pipe,buf,sizeof(buf),&rsize,NULL) && rsize == 0)break;
              buf[rsize] = '\0';
              if(rsize > 0 && buf[0] == '\0'){
                end = TRUE;
                break;
              }
              const BYTE *p = buf;
              while(1){
                DWORD wsize;
                if(!WriteFile(hstdout,p,rsize,&wsize,NULL))break;
                if(wsize == 0)break;
                p += wsize;
                rsize -= wsize;
                if(rsize == 0)break;
              }
            }
            buf[0] = '\n';
            DWORD wsize;
            WriteFile(hstdout,buf,1,&wsize,NULL);
            FlushFileBuffers(pipe);
            DisconnectNamedPipe(pipe);
            if(end)break;
          }
        }
        CloseHandle(pipe);
      }else{
        fprintf(stderr,"failed to create a pipe, error code = %d\n",GetLastError());
        rv = 2;
      }
      ReleaseMutex(mutex);
      CloseHandle(mutex);
    }else{
      fwprintf(stderr,_T("server %s is already executed\n"),totalname + lstrlen(g_nameprefix));
      rv = 1;
    }
  }else{
    while(1){
      pipe = CreateFile(totalname,GENERIC_READ | GENERIC_WRITE,0,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);
      if(pipe != INVALID_HANDLE_VALUE)break;
      if(GetLastError() != ERROR_PIPE_BUSY){
        fprintf(stderr,"failed to open pipe, error code = %d\n",GetLastError());
        rv = 3;
        break;
      }
      if(!WaitNamedPipe(totalname, 2000)){
        fprintf(stderr,"failed to open pipe, time out\n");
        rv = 4;
        break;
      }
    }
    if(pipe != INVALID_HANDLE_VALUE){
      if(MyCompareString(act,actlen,_T("stop"),4) == 0){
        BYTE buf[2];
        buf[0] = '\0';buf[1] = '\0';
        DWORD wsize;
        WriteFile(pipe,buf,2,&wsize,NULL);
      }else{
        //UTF-8ɕϊ
        DWORD utf8size = WideCharToMultiByte(CP_UTF8,0,str,strlen,NULL,0,NULL,NULL);
        char *utf8buf = (char*)HeapAlloc(heap,HEAP_ZERO_MEMORY,sizeof(char)*(utf8size + 1));
        WideCharToMultiByte(CP_UTF8,0,str,strlen,utf8buf,utf8size,NULL,NULL);
        DWORD wsize;
        WriteFile(pipe,utf8buf,lstrlenA(utf8buf)*sizeof(char),&wsize,NULL);
      }
      CloseHandle(pipe);
    }
  }
  HeapFree(heap,0,totalname);
  HeapDestroy(heap);
  return rv;
}
