// http://hidemaruo.dip.jp:81/hidesoft/hidesoft_2/x31876.html

#include <windows.h>
#include <tchar.h>
#include <process.h>
#include <shlwapi.h>
#include <stdlib.h>
#include <string>
#include <vector>

#define EXPORT extern "C" __declspec(dllexport)

const int BUFFERSIZE = 1024;
typedef std::basic_string<TCHAR> tstring;
enum TODO{
	TODO_NOTHING,
	TODO_OUTPUT,
	TODO_EVALMACRO,
	TODO_EXECMACROFILE,
};


#pragma data_seg(".abenori_latexmkerr_shared")
TCHAR shared_buffer[BUFFERSIZE] = _T("");
wchar_t shared_wbuffer[BUFFERSIZE] = L"";
TCHAR shared_dll_path[MAX_PATH] = _T("");
intptr_t shared_HidemaruHandle = 0;
TODO shared_todo = TODO_NOTHING;
#pragma data_seg()

const TCHAR* EVENTNAME = _T("ABENORI_LATEXMKERR_EVENT_HIDEMARU");

class Lock{
	HANDLE mutex = NULL;
public:
	void lock(){
		mutex = CreateMutex(nullptr,FALSE,"ABENORI_LATEXMKERR_MUTEX");
		if(mutex)WaitForSingleObject(mutex,INFINITE);
	}
	void unlock(){
		if(mutex){
			ReleaseMutex(mutex);
			CloseHandle(mutex);
			mutex = NULL;
		}
	}
	Lock(){lock();}
	~Lock(){unlock();}
};

typedef intptr_t (*OUTPUTPROC)(intptr_t,const char*);
typedef intptr_t (*PUSHPROC)(intptr_t);
typedef intptr_t (*POPPROC)(intptr_t);
typedef intptr_t (*GETWINDOWHANDLEPROC)(intptr_t);

OUTPUTPROC OutputProc;
PUSHPROC PushProc;
POPPROC PopProc;
GETWINDOWHANDLEPROC GetWindowHandleProc;

#define WM_ISMACROEXECUTING (WM_USER + 167)
#define WM_REMOTE_EXECMACRO_FILE (WM_USER + 271)
#define WM_REMOTE_EXECMACRO_MEMORY (WM_USER + 272)
#define WM_REMOTE_EVALMACRO (WM_USER + 282)

HANDLE thread = NULL;
unsigned int threadid = 0;
HMODULE dll = NULL;

const std::wstring MARKDATA = L"532148";

bool endthread = false;
unsigned int WINAPI ThreadInHidemaru(void *arg){
	auto event = OpenEvent(EVENT_ALL_ACCESS,FALSE,EVENTNAME);
	while(true){
		WaitForSingleObject(event,INFINITE);
		{
			Lock l;
			switch(shared_todo){
			case TODO_OUTPUT:
				OutputProc(shared_HidemaruHandle,shared_buffer);
				*shared_buffer = 0;
				break;
			case TODO_EVALMACRO:
				// ő1b܂
				for(int i = 0; i < 10 ; ++i){
					if(SendMessage(reinterpret_cast<HWND>(shared_HidemaruHandle),WM_ISMACROEXECUTING,NULL,NULL))Sleep(100);
					else{
						SendMessage(reinterpret_cast<HWND>(shared_HidemaruHandle),WM_REMOTE_EXECMACRO_MEMORY,NULL,reinterpret_cast<LPARAM>(shared_wbuffer));
						break;
					}
				}
				break;
			case TODO_EXECMACROFILE:
				// ő1b܂
				for(int i = 0; i < 10 ; ++i){
					if(SendMessage(reinterpret_cast<HWND>(shared_HidemaruHandle),WM_ISMACROEXECUTING,NULL,NULL))Sleep(100);
					else{
						SendMessage(reinterpret_cast<HWND>(shared_HidemaruHandle),WM_REMOTE_EXECMACRO_FILE,NULL,reinterpret_cast<LPARAM>(shared_wbuffer));
						break;
					}
				}
				break;
			default:
				break;
			}
			shared_todo = TODO_NOTHING;
			if(endthread)return 0;
			ResetEvent(event);
		}
	}
}

void WaitThreadInHidemaru(){
	for(int i = 0; i < 100 ; ++i){
		bool end;
		{Lock l;end = (shared_todo == TODO_NOTHING);}
		if(end)return;
	}
}


std::string utf8_to_sjis(const char *s){
	wchar_t *wbuf;
	auto wlen = ::MultiByteToWideChar(CP_UTF8, 0, s, ::lstrlen(s), NULL, 0);
	wbuf = new wchar_t[wlen + 2];
	wlen = ::MultiByteToWideChar(CP_UTF8, 0, s, ::lstrlen(s), wbuf, wlen + 1);
	wbuf[wlen] = '\0';
	char *cbuf;
	auto clen = ::WideCharToMultiByte(CP_ACP, 0, wbuf, wlen, NULL, 0, NULL, NULL);
	cbuf = new char[clen + 1];
	clen = ::WideCharToMultiByte(CP_ACP, 0, wbuf, wlen, cbuf, clen, NULL, NULL);
	cbuf[clen] = '\0';
	tstring rv(cbuf);
	delete[] wbuf;
	delete[] cbuf;
	return rv;
}

std::wstring to_utf16(int cp,const char *s){
	wchar_t *wbuf;
	auto wlen = ::MultiByteToWideChar(cp, 0, s, ::lstrlen(s), NULL, 0);
	wbuf = new wchar_t[wlen + 2];
	wlen = ::MultiByteToWideChar(CP_UTF8, 0, s, ::lstrlen(s), wbuf, wlen + 1);
	wbuf[wlen] = '\0';
	std::wstring rv(wbuf);
	return rv;
}

std::wstring utf8_to_utf16(const char *s){return to_utf16(CP_UTF8,s);}
std::wstring sjis_to_utf16(const char *s){return to_utf16(CP_ACP,s);}


/** HmOutputPane.dllCID
* Gۃ}ŇĂяozD
* @return TRUE
*/
EXPORT int FreeDLL(){
	if(thread){
		{Lock l;endthread = true;}
		SetEvent(OpenEvent(EVENT_ALL_ACCESS,FALSE,EVENTNAME));
		if(WaitForSingleObject(thread,2000) == WAIT_TIMEOUT)TerminateThread(thread,0);
		CloseHandle(thread);
		thread = NULL;
	}
	if(dll){
		FreeLibrary(dll);
		dll = NULL;
	}
	return TRUE;
}


/** HmOutputPane.dll[hCKvȏsD
* Gۃ}ŇĂяozD
* @param hidemarudir hidemaru.exe, HmOutputPane.dll̂fBNgD
* @param handle GۃEBhẼnh
* @return TRUECsFALSE
*/

EXPORT int LoadDLL(const TCHAR *hidemarudir,int handle){
	Lock l;
	FreeDLL();
	lstrcpy(shared_dll_path,hidemarudir);
	lstrcat(shared_dll_path,_T("\\HmOutputPane.dll"));
	dll = LoadLibrary(shared_dll_path);
	if(dll == NULL)return FALSE;
	OutputProc = (OUTPUTPROC)GetProcAddress(dll,_T("Output"));
	PushProc = (PUSHPROC)GetProcAddress(dll,_T("Push"));
	PopProc = (POPPROC)GetProcAddress(dll,_T("Pop"));
	GetWindowHandleProc = (GETWINDOWHANDLEPROC)GetProcAddress(dll,_T("GetWindowHandle"));
	if(OutputProc == nullptr || PushProc == nullptr || PopProc == nullptr || GetWindowHandleProc == nullptr){
		FreeLibrary(dll);
		return FALSE;
	}
	auto event = CreateEvent(nullptr,TRUE,FALSE,EVENTNAME);
	thread = (HANDLE)::_beginthreadex(nullptr,0,ThreadInHidemaru,nullptr,0,&threadid);
	if(thread == NULL){
		FreeLibrary(dll);
		return FALSE;
	}
	SetThreadPriority(thread,THREAD_ALL_ACCESS);
	endthread = false;
	shared_todo = TODO_NOTHING;
	{Lock l;shared_HidemaruHandle = handle;}
	return TRUE;
}

intptr_t GetWindowHandle(){
	Lock l;
	auto dll = LoadLibrary(shared_dll_path);
	if(dll){
		GETWINDOWHANDLEPROC proc = (GETWINDOWHANDLEPROC)GetProcAddress(dll,"GetWindowHandle");
		if(proc == NULL)return 0;
		auto r = (*proc)(shared_HidemaruHandle);
		FreeLibrary(dll);
		return r;
	}else return 0;
}

/** Gۂ̃EBhEnhw肷DLoadDLLȍ~ɕύXꂽȂǂɎgD
* Gۃ}ŇĂяozD
* @param handle VEBhEnhD
*/
EXPORT int SetHidemaru(int handle){
	Lock l;
	shared_HidemaruHandle = handle;
	return TRUE;
}

/** AEgvbggɕo͂D
* rundll32.exěĂяozD
* @param cmdline o͂镶
*/
EXPORT int Output(HWND,HINSTANCE,const TCHAR *cmdline,int){
	Lock l;
	auto event = OpenEvent(EVENT_ALL_ACCESS,FALSE,EVENTNAME);
	TCHAR *b = shared_buffer;
	while(*cmdline){
		if(*cmdline == '\r'){
			if(*(cmdline + 1) == '\n'){
				*b = '\r';*(b + 1) = '\n';
				b += 2;cmdline += 2;
			}else{
				*b = '\r';*(b + 1) = '\n';
				++cmdline;b += 2;
			}
		}else if(*cmdline == '\n'){
			*b = '\r';*(b + 1) = '\n';
			++cmdline;b += 2;
		}else{
			*b = *cmdline;++cmdline;++b;
		}
		if(b - shared_buffer > BUFFERSIZE - 4){
			*b = '\0';
			shared_todo = TODO_OUTPUT;
			SetEvent(event);
			l.unlock();
			WaitThreadInHidemaru();
			l.lock();
			b = shared_buffer;
		}
	}
	*b = '\0';
	shared_todo = TODO_OUTPUT;
	SetEvent(event);
	l.unlock();
	WaitThreadInHidemaru();
	return 0;
}

int Output(const TCHAR *str){
	return Output(NULL,NULL,str,0);
}

/** AEgvbgg\Ă΁Cɕo͂D
* rundll32.exěĂяozD
* @param cmdline o͂镶
*/
EXPORT int OutputIfPanelExists(HWND,HINSTANCE,const TCHAR *cmdline,int){
	if(GetWindowHandle())return Output(cmdline);
	else return FALSE;
}

/** AEgvbgg
* rundll32.exěĂяozD
* @return TRUECsFALSE
*/
EXPORT int Close(HWND,HINSTANCE,const char*,int){
	HWND hwnd = (HWND)GetWindowHandle();
	if(!hwnd)return FALSE;
	SendMessage(hwnd,WM_COMMAND,1001,0);
	return TRUE;
}
int Close(){return Close(NULL,NULL,nullptr,0);}

/** AEgvbggNAD
* rundll32.exěĂяozD
* @return TRUECsFALSE
*/
EXPORT int Clear(HWND,HINSTANCE,const char*,int){
	HWND hwnd = (HWND)GetWindowHandle();
	if(!hwnd)return FALSE;
	SendMessage(hwnd,WM_COMMAND,1009,0);
	return TRUE;
}
int Clear(){return Clear(NULL,NULL,nullptr,0);}

void EvalMacroW(const wchar_t *macro){
	lstrcpyW(shared_wbuffer,macro);
	{
	Lock l;
		auto event = OpenEvent(EVENT_ALL_ACCESS,FALSE,EVENTNAME);
		shared_todo = TODO_EVALMACRO;
		SetEvent(event);
		l.unlock();
	}
	WaitThreadInHidemaru();
}

EXPORT int EvalMacro(HWND,HINSTANCE,const char *macro,int){
	auto m = sjis_to_utf16(macro);
	EvalMacroW(m.c_str());
	return TRUE;
}

EXPORT int EvalMacroUTF8(HWND,HINSTANCE,const char *macro,int){
	auto m = utf8_to_utf16(macro);
	EvalMacroW(m.c_str());
	return TRUE;
}

void ExecMacroFileW(const wchar_t *file){
	lstrcpyW(shared_wbuffer,file);
	{
	Lock l;
		auto event = OpenEvent(EVENT_ALL_ACCESS,FALSE,EVENTNAME);
		shared_todo = TODO_EXECMACROFILE;
		SetEvent(event);
		l.unlock();
	}
	WaitThreadInHidemaru();
}

EXPORT int ExecMacroFile(HWND,HINSTANCE,const char *file,int){
	auto m = sjis_to_utf16(file);
	ExecMacroFileW(m.c_str());
	return TRUE;
}

EXPORT int ExecMacroFileUTF8(HWND,HINSTANCE,const char *file,int){
	auto m = utf8_to_utf16(file);
	ExecMacroFileW(m.c_str());
	return TRUE;
}

/** LatexmksƂɌĂяoD
* rundll32.exěĂяozD
* @param cmdline et@CD
* @return TRUED
*/
EXPORT int LatexmkFailure(HWND,HINSTANCE,const TCHAR *cmdline,int){
	Output(_T(""));
	Clear();
	tstring log;
	auto sep = ::_tcsstr(cmdline,_T(":"));
	if(sep == nullptr)return FALSE;
	tstring mode = tstring(cmdline).substr(0,sep - cmdline);
	mode = "," + mode + ",";
	bool title = (mode.find(_T(",title,")) != std::string::npos);
	bool output = (mode.find(_T(",output,")) != std::string::npos);
	bool mark = (mode.find(_T(",mark,")) != std::string::npos);
	bool message = (mode.find(_T(",message,")) != std::string::npos);
	auto r = ::PathFindExtension(sep + 1);
	if(r == nullptr)log = tstring(sep + 1) + _T(".log");
	else log = tstring(sep + 1).substr(0, r - sep - 1) + _T(".log");
	FILE *fp;
	tstring s = _T("");
	std::wstring errfile = L"";
	std::wstring errmsg = L"";
	std::wstring undefcs = L"";
	int errline = 0;
	bool is_error_undef = false;
	if(_tfopen_s(&fp,log.c_str(),_T("r")) == 0){
		char line[1024];
		while(fgets(line,1023,fp)){
			if(line[0] == 'l' && line[1] == '.' && ('0' <= line[2] && line[2] <= '9')){
//				s = s + line;
//				if(s[s.length() - 1] != '\n')s += _T("\n");
			}else{
				auto p = _tcsstr(line,_T(":"));
				// <file>:<line>:ƂтT
				if(p == nullptr)continue;
				if('0' > *(p + 1) || *(p + 1) > '9')continue;
				auto q = p + 2;
				while('0' <= *q && *q <= '9')++q;
				if(*q != ':')continue;
				*p = '(';*q = '\0';
				if(errline == 0){
					errline = atoi(p + 1);
					errfile = utf8_to_utf16(std::string(line).substr(0,p - line).c_str());
				}
				s += utf8_to_sjis(line) + _T("):") + (q + 1);
				++q;
				while(*q == ' ')++q;
				errmsg = utf8_to_utf16(q);
				const char *undeferr = "Undefined control sequence";
				is_error_undef = (strncmp(q,undeferr,::lstrlen(undeferr)) == 0);
				if(s[s.length() - 1] != '\n')s += _T("\n");
				if(_fgetts(line,1023,fp)){
					while(line[0] != 'l' || line[1] != '.' || (!(('0' <= line[2] && line[2] <= '9')))){
						s += line;
						if(s.length() > 0 && s[s.length() - 1] != '\n')s += _T("\n");
						if(!_fgetts(line,1023,fp))break;
					}
					if(line[0] == 'l' && line[1] == '.' && ('0' <= line[2] && line[2] <= '9')){
						p = line + 3;
						while('0' <= *p && *p <= '9')++p;
						if(*p == ' '){
							if(is_error_undef){
								auto curerrstr = utf8_to_utf16(p + 1);
								// ߂AEg
								auto r = curerrstr.rfind('\\');
								if(r != std::string::npos){
									undefcs = curerrstr.substr(r);
								}
							}
							s += utf8_to_sjis(line);
							if(s.length() > 0 && s[s.length() - 1] != '\n')s += _T("\n");
							if(_fgetts(line,1023,fp)){
								bool onlyspace = true;
								for(p = line ; *p ; ++p){
									if(*p != ' ' && *p != '\n'){
										onlyspace = false;
										break;
									}
								}
								if(!onlyspace){
									s += utf8_to_sjis(line);
									if(s.length() > 0 && s[s.length() - 1] != '\n')s += _T("\n");
								}
							}
						}
					}
				}
			}
		}
	}
	if(output){
		if(s != _T(""))Output(s.c_str());
		else Output(_T("(Latexmk) Error found: see the console or the log file\n"));
	}
	std::wstring macro = L"";
	if(errfile != L"" && errline >= 0){
		errmsg = L"(" + errfile + L"):" + errmsg;
	}else{
		errmsg = L"ĎĂt@C̃RpCG[";
	}
	if(mark){
		macro += L"deletecolormarker \"\"," + MARKDATA + L";";
		if(undefcs != L""){
			undefcs = L"\\" + undefcs;
			macro +=
				L"##st = strstr(gettext2(0," + std::to_wstring(errline) + L",99999," + std::to_wstring(errline) + L",1),\"" + undefcs + L"\");\n" + 
				L"if(##st == -1){##st = 0;##en = 9999;}else{##en = ##st + strlen(\"" + undefcs + L"\");}\n" +
				L"colormarker getconfigcolor(10,0),getconfigcolor(10,1),getconfigcolor(10,2),2," + MARKDATA + L",\"\","
				+ std::to_wstring(errline) + L",##st," + std::to_wstring(errline) + L",##en;\n";
		}else{
			macro += 
				L"colormarker getconfigcolor(10,0),getconfigcolor(10,1),getconfigcolor(10,2),2," + MARKDATA + L",\"\"," + std::to_wstring(errline) + L",0," + std::to_wstring(errline) + L",9999;\n";
		}
	}
	if(title){
		macro += L"title \"" + errmsg + L"\";title -1;";
	}
	if(message){
		macro += L"message \"" + errmsg + L"\";";
	}
	if(macro != L""){
		if(errfile[0] == '.' && errfile[1] == '/')errfile = errfile.substr(2);
		macro = L"if(basename == tolower(\"" + errfile + L"\")){\n" + macro + L"\n}";
		EvalMacroW(macro.c_str());
//		MessageBoxW(NULL,macro.c_str(),NULL,0);
	}
	return TRUE;
}

/** LatexmkƂɌĂяoD
* rundll32.exěĂяozD
* @param cmdline "mode:file1:file2"̌`
* @return TRUED
*/
EXPORT int LatexmkSuccess(HWND,HINSTANCE,const TCHAR *cmdline,int){
	auto sep = ::_tcsstr(cmdline,_T(":"));
	if(sep == nullptr)return TRUE;
	tstring mode = tstring(cmdline).substr(0,sep - cmdline);
	mode = "," + mode + ",";
	auto r = ::_tcsstr(sep + 1,_T(":"));
	tstring from,to;
	if(r != nullptr){
		from = tstring(sep + 1).substr(0,r - sep - 1);
		to = (r + 1);
	}else from = (sep + 1);
	bool opentmp = (mode.find(_T(",opentmp,")) != std::string::npos);
	bool output = (mode.find(_T(",output,")) != std::string::npos);
	bool title = (mode.find(_T(",title,")) != std::string::npos);
	bool mark = (mode.find(_T(",mark,")) != std::string::npos);
	std::wstring macro = L"";
	if(output)Close();
	if(opentmp && from != _T("") && to != _T(""))CopyFile(from.c_str(),to.c_str(),FALSE);
	if(mark)macro += L"deletecolormarker \"\"," + MARKDATA + L";";
	if(title)macro += L"title 0;";
	if(macro != L"")EvalMacroW(macro.c_str());
	return TRUE;
}

BOOL APIENTRY DllMain(HINSTANCE hInstance, DWORD ul_reason_for_call, LPVOID pParam){
	switch (ul_reason_for_call) {
	case DLL_THREAD_ATTACH:
		thread = NULL;dll = NULL;
		return TRUE;
	case DLL_PROCESS_DETACH:
		FreeDLL();
		return TRUE;
	default:
		break;
	}
	return TRUE;
}
